#USES classes\_global.vbs
#USES classes\_CFile.vbs
#USES classes\_CFileVar.vbs
#USES classes\_CToolbar.vbs
#USES classes\_CTLBFolder.vbs
#USES classes\_CTLBData.vbs

set script = new_CFile(wscript.scriptFullName)
set toolbar = new_CToolbar(FLD_TOOLBAR)

set presetsXML = createObject("Microsoft.XMLDOM")
presetsXML.Async = false
presetsXML.setProperty "SelectionLanguage", "XPath"
presetsXMLPath = gfs.buildPath(FLD_SCRIPTS, "presets.xml")
presetsXML.load(presetsXMLPath)


set presetVar = get_CFileVar(toolbar.folder, "Preset")

presetName = inputBox("Enter preset name:", "Save Preset", presetVar.value)
if presetName = "" then wscript.quit

xpathPresets = "presets"
xpathPreset = xpathPresets & "/preset"
xpathNamedPreset = xpathPreset & "[@name='" & presetName & "']"
xpathDefaultPreset = xpathPreset & "[@name='Default']"


set presetsNode = presetsXML.selectSingleNode(xpathPresets)

set namedPresetNode = presetsXML.selectSingleNode(xpathNamedPreset)
if namedPresetNode is nothing then
	set namedPresetNode = presetsXML.createElement("preset")
	namedPresetNode.setAttribute "name", presetName
	presetsNode.appendChild namedPresetNode
end if	


set iconNode = presetsXML.selectSingleNode(xpathNamedPreset & "/icon")
if iconNode is nothing then
	set iconNode = presetsXML.createElement("icon")
	namedPresetNode.appendChild iconNode
end if
set iconNode = presetsXML.selectSingleNode(xpathNamedPreset & "/icon")
iconNode.setAttribute "position", get_CFileVar(FLD_ICON, "Position").value
iconNode.setAttribute "size", get_CFileVar(FLD_ICON, "Size").value
iconNode.setAttribute "opacity", get_CFileVar(FLD_ICON, "Opacity").value


set captionMenu = new_CTLBFolder(gfs.buildPath(toolbar.folder, "Caption"))
set captionMenuTLBData = load_CTLBData(captionMenu.tlbdata)
set captionNode = presetsXML.selectSingleNode(xpathNamedPreset & "/caption")
if captionNode is nothing then
	set captionNode = presetsXML.createElement("caption")
	namedPresetNode.appendChild captionNode
end if
set captionNode = presetsXML.selectSingleNode(xpathNamedPreset & "/caption")
captionNode.setAttribute "position", get_CFileVar(FLD_CAPTION, "Position").value
captionNode.setAttribute "fontSize", get_CFileVar(FLD_CAPTION, "Font Size").value
captionNode.setAttribute "show", get_CFileVar(FLD_CAPTION, "Show").value
captionNode.setAttribute "fontColor", captionMenuTLBData.getItemAttribute("Font Color.vbs", "leftText")


set overlayMenu = new_CTLBFolder(gfs.buildPath(toolbar.folder, "Overlay"))
set overlayMenuTLBData = load_CTLBData(overlayMenu.tlbdata)
set overlayNode = presetsXML.selectSingleNode(xpathNamedPreset & "/overlay")
if overlayNode is nothing then
	set overlayNode = presetsXML.createElement("overlay")
	namedPresetNode.appendChild overlayNode
end if
set overlayNode = presetsXML.selectSingleNode(xpathNamedPreset & "/overlay")
overlayNode.setAttribute "position", get_CFileVar(FLD_OVERLAY, "Position").value
overlayNode.setAttribute "fontSize", get_CFileVar(FLD_OVERLAY, "Font Size").value
overlayNode.setAttribute "show", get_CFileVar(FLD_OVERLAY, "Show").value
overlayNode.setAttribute "fontColor", overlayMenuTLBData.getItemAttribute("Font Color.vbs", "leftText")
overlayNode.setAttribute "backgroundColor", overlayMenuTLBData.getItemAttribute("Background Color.vbs", "leftText")

presetsXML.save(presetsXMLPath)

presetVar.setValue presetName

set sc = gws.createShortcut(gfs.buildPath(presetVar.fullPath, presetVar.value & ".lnk"))
sc.targetPath = gfs.buildPath(FLD_SCRIPTS, "usePreset.vbs")
sc.workingDirectory = FLD_SCRIPTS
sc.arguments = """" & presetVar.value & """"
sc.save
