#USES classes\_global.vbs
#USES classes\_CFile.vbs
#USES classes\_CTLBFolder.vbs
#USES classes\_CINIFile.vbs
#USES classes\_CTLBData.vbs
#USES classes\_CFinder.vbs
#USES classes\_CFileVar.vbs

set script = new_CFile(wscript.scriptFullName)

if not IM_isInstalled then
    reply = msgbox("This skin uses ImageMagick for image manipulation on-the-fly. Please install it first." & vbcrlf & vbcrlf & _
           "*** Click OK to go to the download page (www.imagemagick.org) ***", _
           vbOkCancel, "Tiles Install")
    if reply = vbOk then
        gws.run "http://www.imagemagick.org/script/binary-releases.php#windows"
    end if    
    wscript.quit
end if

gfs.deleteFolder(gfs.buildPath(FLD_TLBSKINS, "M8 Tile Editor"), true)
copyFiles
createScriptWrappers
createShortcuts
setPaths
defineToolbars

msg = "M8 Tile Editor installation successful!" & vbcrlf & vbcrlf & _
	  "Create a new toolbar selecting M8 from the predefined toolbars list." & vbcrlf & _
	  "Dock side: right, Full Row. Toolbar style = Taskbar"
msgbox msg, vbInformation, "M8 Tile Editor"

function IM_isInstalled

    dim msgs
    
    on error resume next
        set img = CreateObject("ImageMagickObject.MagickImage.1")
        msgs = img.Convert("logo:", "logo.gif")
    on error goto 0   
    
    if msgs = "640,480,GIF" then
        IM_isInstalled = true
    else
        IM_isInstalled = false
    end if    

end function

function copyFiles

    set fld = gfs.getFolder(gfs.buildPath(script.folder, "skins"))
    for each f in fld.subFolders
		gfs.copyFolder f, FLD_TLBSKINS & "/", true
    next
	
	set fvar = get_CFileVar(FLD_TOOLBAR, "Tile Size")
	fvar.hide

	set fvar = get_CFileVar(FLD_TOOLBAR, "Tile Color")
	fvar.hide
	
end function


sub createScriptWrappers

	set tileScript = new_CFile(gfs.buildPath(FLD_TOOLBAR, "Tile.wsf"))
	if gfs.fileExists(tileScript.fullpath) then
		gfs.deleteFile tileScript.fullpath, true
    end if
    createScriptWrapper tileScript.fullpath, "setTile.vbs"
	tileScript.setHidden
    createScriptWrapper gfs.buildPath(FLD_TOOLBAR, "Use.wsf"), "use.vbs"  
    createScriptWrapper gfs.buildPath(FLD_TOOLBAR, "Save.wsf"), "save.vbs"  
    createScriptWrapper gfs.buildPath(FLD_TOOLBAR, "Clear.wsf"), "clear.vbs"  
    createScriptWrapper gfs.buildPath(FLD_TOOLBAR, "Refresh.wsf"), "refresh.vbs"  

end sub

sub createShortcuts

	set finder = new CFinder
	set shortcuts = finder.findShortcuts(FLD_TOOLBAR, true)
	for each shortcut in shortcuts
		set sc = gws.createShortcut(shortcut)
		set scf = new_CFile(sc.targetPath)
		sc.targetPath = gfs.buildPath(FLD_SCRIPTS, scf.filename)
		sc.save
	next	
	
	set tileShortcut = new_CFile(gfs.buildPath(FLD_TOOLBAR, "Tile.lnk"))
	set tilesc = gws.createShortcut(tileShortcut.fullPath)
	tilesc.targetPath = gfs.buildPath(FLD_TOOLBAR, "Tile.wsf")
	tilesc.save
	
end sub

sub setPaths

    set setupINI = new CINIFile
    setupINI.load gfs.buildPath(FLD_TOOLBAR, "setup.ini")
    setupINI.setKeyValue "settings", "SkinFile", gfs.buildPath(FLD_HOME, "tlbskin.ini")
    setupINI.save gfs.buildPath(FLD_TOOLBAR, "setup.ini")
    set setupINI = nothing
	
	set backgrounds = new_CTLBFolder(gfs.buildPath(FLD_TOOLBAR, "Backgrounds"))
	set backgroundsTLBData = load_CTLBData(backgrounds.tlbdata)
	backgroundsTLBData.setOption "skin", gfs.buildPath(FLD_TLBSKINS, "M8\tlbskin.ini")
	backgroundsTLBData.save

	set saved = new_CTLBFolder(gfs.buildPath(FLD_TOOLBAR, "saved"))
	set savedTLBData = load_CTLBData(saved.tlbdata)
	savedTLBData.setOption "skin", gfs.buildPath(FLD_TLBSKINS, "M8\tlbskin.ini")
	savedTLBData.save
	
	
end sub


sub defineToolbars

    tbName = "M8 Tile Editor"

    set xmlDoc = CreateObject("Microsoft.XMLDOM")
    xmlDoc.Async = "False"
'    msgbox F_TLBOPTIONS
    xmlDoc.Load(F_TLBOPTIONS)

    set toolbarNode=xmlDoc.selectSingleNode("//toolbars/toolbar[@name='" & tbName & "']")

    ' if the toolbar definition already exists then update it, else create it
    if not toolbarNode is nothing then
        toolbarNode.setAttribute "path", FLD_TOOLBAR
    else        
        set toolbarsNode=xmlDoc.selectSingleNode("//toolbars")
        set newToolbarNode  = xmlDoc.CreateElement("toolbar")
        newToolbarNode.setAttribute "name", tbName
        newToolbarNode.setAttribute "path", FLD_TOOLBAR
        toolbarsNode.AppendChild(newToolbarNode)
        set newToolbarNode = nothing
    end if
    set toolbarNode = nothing
    
    xmlDoc.save(F_TLBOPTIONS)

end sub

