#USES classes\_global.vbs
#USES classes\_CFile.vbs
#USES classes\_CFileVar.vbs
#USES classes\_CToolbar.vbs
#USES classes\_CTLBFolder.vbs
#USES classes\_CTLBData.vbs


if wscript.arguments.count = 1 then
	value = wscript.arguments(0)
else
	wscript.quit
end if 

set script = new_CFile(wscript.scriptFullName)
set toolbar = new_CToolbar(FLD_TOOLBAR)

set presetsXML = createObject("Microsoft.XMLDOM")
presetsXML.Async = false
presetsXML.setProperty "SelectionLanguage", "XPath"
presetsXML.load(gfs.buildPath(FLD_SCRIPTS, "presets.xml"))


function mergeNodes(xmldoc, xpath1, xpath2)

	set node1 = xmldoc.selectSingleNode(xpath1)
	set node2 = xmldoc.selectSingleNode(xpath2)
	if node1 is nothing then
		set node1 = node2
	else
		for each attribute in node2.attributes
			if isNull(node1.getAttribute(attribute.name)) then
				node1.setAttribute attribute.name, attribute.value
			end if	
		next	
	end if
	set mergeNodes = node1

end function

function nvl(pVar, pValueIfNull)

	nvl = pVar
	if isNull(nvl) then nvl = pValueIfNull

end function


xpathPresetPrefix = "presets/preset[@name='" & value & "']/"
xpathDefaultPresetPrefix = "presets/preset[@name='Default']/"

set fvar = new_CFileVar(toolbar.folder, "Preset", value)

'Icon
set iconNode = mergeNodes(presetsXML, xpathPresetPrefix & "icon", xpathDefaultPresetPrefix & "icon")

set fvar = new_CFileVar(FLD_ICON, "Position", nvl(iconNode.getAttribute("position"), ""))
set fvar = new_CFileVar(FLD_ICON, "Size", nvl(iconNode.getAttribute("size"), ""))
set fvar = new_CFileVar(FLD_ICON, "Opacity", nvl(iconNode.getAttribute("opacity"), ""))
'End Icon

'Caption
set captionNode = mergeNodes(presetsXML, xpathPresetPrefix & "caption", xpathDefaultPresetPrefix & "caption")
set captionMenu = new_CTLBFolder(gfs.buildPath(toolbar.folder, "Caption"))
set captionMenuTLBData = load_CTLBData(captionMenu.tlbdata)

set fvar = new_CFileVar(FLD_CAPTION, "Show", nvl(captionNode.getAttribute("show"), ""))
set fvar = new_CFileVar(FLD_CAPTION, "Position", nvl(captionNode.getAttribute("position"), ""))
set fvar = new_CFileVar(FLD_CAPTION, "Font Size", nvl(captionNode.getAttribute("fontSize"), ""))

captionMenuTLBData.setItemAttribute "Font Color.vbs", "leftText", nvl(captionNode.getAttribute("fontColor"), "")
captionMenuTLBData.save
'End Caption

' Overlay
set overlayNode = mergeNodes(presetsXML, xpathPresetPrefix & "overlay", xpathDefaultPresetPrefix & "overlay")
set overlayMenu = new_CTLBFolder(gfs.buildPath(toolbar.folder, "overlay"))
set overlayMenuTLBData = load_CTLBData(overlayMenu.tlbdata)

set fvar = new_CFileVar(FLD_OVERLAY, "Show", nvl(overlayNode.getAttribute("show"), ""))
set fvar = new_CFileVar(FLD_OVERLAY, "Position", nvl(overlayNode.getAttribute("position"), ""))
set fvar = new_CFileVar(FLD_OVERLAY, "Font Size", nvl(overlayNode.getAttribute("fontSize"), ""))

overlayMenuTLBData.setItemAttribute "Background Color.vbs", "leftText", nvl(overlayNode.getAttribute("backgroundColor"), "")
overlayMenuTLBData.setItemAttribute "Font Color.vbs", "leftText", nvl(overlayNode.getAttribute("fontColor"), "")
overlayMenuTLBData.save
'End Overlay

gws.sendkeys HK_TEREFRESH
