function new_CFileVar(pFolder, pName, pValue)

    set new_CFileVar = new CFileVar
	new_CFileVar.folder = pFolder
    new_CFileVar.name = pName
	new_CFileVar.setValue pValue

end function 

function get_CFileVar(pFolder, pName)

    set get_CFileVar = new CFileVar
	get_CFileVar.folder = pFolder
    get_CFileVar.name = pName
	get_CFileVar.value = empty
	
	set varFile = get_CFileVar.getVarFile

	if not varFile is nothing then
		varFileName = varFile.name
		split1 = split(varFileName, "[")
		if ubound(split1) = 1 then
			split2 = split(split1(1), "]")
			get_CFileVar.value = split2(0)	
		end if
	end if	
	
end function 


class CFileVar

	public name
	
	public value
	
	public folder

	public function getVarFile
	
		set getVarFile = nothing
		set fld = gfs.getFolder(folder)

		for each f in fld.subFolders
			if NOT instr(f.name, name & " [") = 0 then
				set getVarFile = gfs.getFolder(f.path)
				exit for
			end if	
		next
		
		if getVarFile is nothing then
			for each f in fld.files
				if NOT instr(f.name, name & " [") = 0 then	
					set getVarFile = gfs.getFile(f.path)
					exit for
				end if	
			next
		end if	
		
	end function

	public sub hide
	
		set f = gfs.getFolder(fullpath)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if

	end sub
	
	public function fullPath
	
		fullPath = gfs.buildPath(folder, name & " [" & value & "]")
		
	end function

	public sub setValue(pValue)
		
		value = pValue
		set varFile = getVarFile

		if not varFile is nothing then
			ext = gfs.getExtensionName(varFile.path)
			if not ext = "" then
				if not gfs.fileExists(fullPath & "." & ext) then
				    done = false
					timer1 = 0
					do
						on error resume next
						varFile.name = gfs.getBaseName(fullPath) & "." & ext
						if err.number = 0 then
							done = true
							on error resume next
						else	
							wscript.sleep 100
							timer1 = timer1 + 100
						end if
					loop until done or timer1 > 2000		
				end if	
			else
				if not gfs.folderExists(fullPath) then
				    done = false
					timer2 = 0
					do
						on error resume next
						varFile.name = gfs.getBaseName(fullPath) & "." & ext
						if err.number = 0 then
							done = true
							on error resume next
						else	
							wscript.sleep 100
							timer2 = timer2 + 100
						end if
					loop until done or timer2 > 2000
				end if
			end if	
		end if	

	end sub
 
    
    
    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "value: " & value & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "fullpath: " & fullpath

    end function

    public sub show
    
        msgbox toString, vbInformation, "CFileVar" 
        
    end sub
	
end class 