#USES classes\_global.vbs
#USES classes\_CTLBData.vbs
#USES classes\_CINIFile.vbs
#USES classes\_CFinder.vbs

function new_CTLBFolder(pPath)

    set this = new CTLBFolder
    this.path = pPath
    set new_CTLBFolder = this
    
end function 'new_CTLBFolder

class CTLBFolder

    public path    
    
    public function name 
        name = gfs.getBaseName(path)
    end function

    public function folder 
        folder = gfs.getParentFolderName(path)
    end function
    
    public function tlbdata
        tlbdata = gfs.buildPath(path, "tlbdata.xml")
    end function    

    public function setup
        setup = gfs.buildPath(path, "setup.ini")
    end function    

	function isToolbar
	
		isToolbar = false
		if gfs.fileExists(tlbdata) and gfs.fileExists(setup) and not gfs.fileExists(gfs.buildPath(path, "namespace.fld")) then
			set lsetupINI = new CINIFile 
			lsetupINI.load(setup)
			if lsetupINI.findKey("Settings", "toolbarHotkey") > 0 then
				isToolbar = true
			end if	
		end if

		end function
    
	function findToolbar
	
		set tmpTLBFolder = me
		do while not tmpTLBFolder.isToolbar
			set tmpTLBFolder = new_CTLBFolder(tmpTLBFolder.folder)
		loop
		set findToolbar = tmpTLBFolder
		
	end function

	function isVirtual
		isVirtual =  gfs.fileExists(gfs.buildPath(folder, "namespace.fld"))
	end function
    
	
	function findVirtualFolders
		
		set vfdict = createObject("Scripting.Dictionary")
		
		set optionsxml = load_CTLBData(F_TLBOPTIONS)
		set toolbars = optionsxml.xmlDoc.selectNodes("//truelaunchbar/toolbars/toolbar")
		for each node in toolbars
			path = node.getAttribute("path")
			if gfs.folderExists(path) then
				set finder = new CFinder
				set foundFiles = finder.findFilesByFilename(path, "namespace.fld", true)
				for each ff in foundFiles.keys
					vfdict.add gfs.getParentFolderName(ff), ""
				next	
			end if
		next
		
		for each node in toolbars
			path = node.getAttribute("path")
			if gfs.folderExists(path) then
				set tbFolder = new_CToolbar(path)
				set setupINI = new CINIFile
				setupINI.load(tbFolder.setup)
				set layouts = setupINI.findSections("layout")
				for each layout in layouts
					layoutPath = setupINI.getKeyValue(layout, "folder")
					if gfs.folderExists(layoutPath) then
						set finder = new CFinder
						set foundFiles = finder.findFilesByFilename(layoutPath, "namespace.fld", true)
						for each ff in foundFiles.keys
							if not vfdict.exists(gfs.getParentFolderName(ff)) then
								vfdict.add gfs.getParentFolderName(ff), ""
							end if
						next	
					end if		
				next
			end if		
		next
		
		set findVirtualFolders = vfdict
		
	end function
	
    public sub create
        gfs.createFolder(path)
    end sub 'create

    public function toString

        toString =  "path: " & path & vbcrlf & _
                    "name: " & name & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "tlbdata: " & tlbdata & vbcrlf & _
                    "setup: " & setup

    end function 'toString

    public sub show
    
        msgbox toString, vbInformation, "CTLBFolder" 
        
    end sub 'show
   
end class    
