#USES classes\_debug.vbs
#USES classes\_global.vbs
#USES classes\_CPoint.vbs

class CTileImage

	public tileSize
	public effect
	
	public iconPath
	public iconSize
	public iconPosition
	public iconOpacity

	public captionText
	public captionPosition
	public captionShow
	public captionFontSize
	public captionFontColor

	public overlayText
	public overlayPosition
	public overlayShow
	public overlayFontSize
	public overlayFontColor
	public overlayBackgroundColor

	public backgroundImagePath
	public path

	
	public sub setIconSize(pSize)
	
		select case pSize
			case "Full"
				iconSize = "120x120"
			case "Big"
				iconSize = "96x96"				
			case "Original"
				iconSize = "100%"
			case "Small"
				iconSize = "48x48"
			case "Smaller"
				iconSize = "32x32"
			case "Oversized"
				iconSize = "192x192"
			case else 
				iconSize = "64x64"
		end select
			
	end sub
	
    public function create

        dim img 
        dim msgs

		if tileSize = "Larger" then
			set dims = new_CPoint("248x120")	
			style = gfs.buildPath(FLD_TOOLBAR, "~~images~~\styles\metro-big.png")
		else
			set dims = new_CPoint("120x120")		
			style = gfs.buildPath(FLD_TOOLBAR, "~~images~~\styles\metro.png")
		end if
		
		if captionShow = "Never" then
			captionNormal = "mpr:blank"
			captionHover = "mpr:blank"
		elseif captionShow = "On hover" then
			captionNormal = "mpr:blank"
			captionHover = "mpr:caption"
		else
			captionNormal = "mpr:caption"
			captionHover = "mpr:caption"
		end if

		if overlayShow = "Never" then
			overlayNormal = "mpr:blank"
			overlayHover = "mpr:blank"
		elseif overlayShow = "On hover" then
			overlayNormal = "mpr:blank"
			overlayHover = "mpr:overlay"
		else
			overlayNormal = "mpr:overlay"
			overlayHover = "mpr:overlay"
		end if

        set img = createObject("ImageMagickObject.MagickImage.1")

		opacity = iconOpacity / 100

		set bgipf = new_CFile(backgroundImagePath)
		bgipbig = gfs.buildPath(bgipf.folder, bgipf.name & "-big." & bgipf.extension)
		if gfs.fileExists(bgipbig) then
			bgip = bgipbig
		else
			bgip = backgroundImagePath
		end if	

		ao = getEffectDef(effect)
		if ubound(ao) = -1 then
			ao = array("-resize", dims.x + 4 & "x" & dims.y + 4 & "!", "-bordercolor", "none", "-border", "2")
		end if

        msgs = img.convert(style, "-shave", "4x4", _
						   "-write", "mpr:style", "+delete", _
						   _
						   "-size", dims.toString, "xc:transparent", _ 
						   "-write", "mpr:blank", "+delete", _							   
						   _
						   bgip, "-resize", dims.toString & "!", _
						   "-write", "mpr:color", "+delete", _
						   _
						   "mpr:color", "mpr:style", "-composite",  _	
						   "-write", "mpr:bg", "+delete", _
						   _
						   iconPath, "-trim", "-resize", iconSize, _
						   "-channel", "Alpha", "-evaluate", "Multiply", opacity, _ 						   
						   "-bordercolor", "none", "-border", "8x4", _
						   "-write", "mpr:icon", "+delete", _ 
						   _
						   "-font", "Segoe-UI-Bold", "-pointsize", captionFontSize, "-fill", captionFontColor, _
						   "-background", "none", "-size", dims.x - 16 & "x", _
						   "-bordercolor", "#00000000", "-border", "8x4", _
						   "-gravity", captionPosition, "caption:" & captionText, _
						   "-write", "mpr:caption", "+delete", _
						   _
						   "-font", "Segoe-UI-Bold", "-pointsize", overlayFontSize, "-fill", overlayFontColor, _
						   "-background", "none", "-size", dims.x - 16 & "x", _
						   "-bordercolor", overlayBackgroundColor, "-border", "8x4", _
						   "-gravity", overlayPosition, "caption:" & overlayText, _
						   "-write", "mpr:overlay", "+delete", _ 
						   _
						   "mpr:bg", "mpr:icon", "-gravity", iconPosition, "-composite", _
						   "-write", "mpr:base", _
						   captionNormal, "-gravity", captionPosition, "-composite", _
						   overlayNormal, "-gravity", overlayPosition, "-composite", _
						   "-write", "mpr:normal", "+delete", _
						   _
						   "mpr:base", _
						   captionHover, "-gravity", captionPosition, "-composite", _
						   overlayHover, "-gravity", overlayPosition, "-composite", _
						   "-bordercolor", "none", "-border", "4", _
						   style, "-gravity", "center", "-composite", _
						   "-write", "mpr:hover", _						   
						   _
						   ao(0), ao(1), ao(2), ao(3), ao(4), ao(5), _
                           "-write", "mpr:active", "+delete", _						   
							_
						   "-bordercolor", "none", "-border", "4", _ 
						   "mpr:normal", _
						   "-bordercolor", "none", "-border", "0", _
						   "mpr:active", "mpr:hover", "-append", path)						   

'						   "-resize", dims.x + 4 & "x" & dims.y + 4 & "!", "-bordercolor", "none", "-border", "2", _

		
        we "msgs1", msgs

        if msgs = "128,384,PNG" then
            create = true 
        end if
                
    end function 'create

	function getEffectDef(pEffect)

        set effectDict = createObject("Scripting.Dictionary")
		
		effectDict.add "Tilt right", array("-matte", "-virtual-pixel", "transparent", "-distort", "Perspective", "0.5,0 0.5,0  0.5,128  0.5,128  128,128 124,124  128,0 124,4")
		effectDict.add "Tilt left", array("-matte", "-virtual-pixel", "transparent", "-distort", "Perspective", "127.5,0 127.5,0  127.5,128  127.5,128  0,128 4,124 0,0 4,4")
		effectDict.add "Tilt down", array("-matte", "-virtual-pixel", "transparent", "-distort", "Perspective", "0,0.5 0,0.5  128,0.5  128,0.5  128,128 124,124  0,128 4,124")
		effectDict.add "Tilt up", array("-matte", "-virtual-pixel", "transparent", "-distort", "Perspective", "0,127.5 0,127.5  128,127.5  128,127.5  128,0 124,4  0,0 4,4")
		
		nullArray = array()
		
		if pEffect = "Random" then
			effectDictItems = effectDict.keys
			randomize
			i = int((effectDict.count)*rnd())
			lEffect = effectDictItems(i)
			effectArray = effectDict(lEffect)
		elseif effectDict.exists(pEffect) then
			effectArray =  effectDict(pEffect)
		else
			effectArray = nullArray
		end if
		
		getEffectDef = effectArray 

	end function		
	
    public function toString

		toString =  "iconPath: " & iconPath & vbcrlf & _
					"iconSize: " & iconSize & vbcrlf & _
					"iconPosition: " & iconPosition & vbcrlf & _
					"iconOpacity: " & iconOpacity & vbcrlf & _
					"captionText: " & captionText & vbcrlf & _
					"captionPosition: " & captionPosition & vbcrlf & _
					"captionShow: " & captionShow & vbcrlf & _
					"captionFontSize: " & captionFontSize & vbcrlf & _
					"captionFontColor: " & captionFontColor & vbcrlf & _
					"overlayText: " & overlayText & vbcrlf & _
					"overlayPosition: " & overlayPosition & vbcrlf & _
					"overlayShow: " & overlayShow & vbcrlf & _
					"overlayFontSize: " & overlayFontSize & vbcrlf & _
					"overlayFontColor: " & overlayFontColor & vbcrlf & _
					"overlayBackgroundColor: " & overlayBackgroundColor & vbcrlf & _					
					"backgroundImagePath: " & backgroundImagePath & vbcrlf & _
					"path: " & path & vbcrlf
					
    end function 'toString

    public sub show
    
        msgbox toString, vbInformation, "CTileImage" 
        
    end sub 'show

    public sub show2(pTitle)
    
        msgbox toString, vbInformation, pTitle 
        
    end sub 'show
	
	private sub Class_Initialize

		tileSize = "Smaller"
		iconSize = "normal"
		iconPosition = "center"
		iconOpacity = 100
		iconOffset = "+0+0"
		captionPosition = "southwest"
		caption = "Untitled"
		captionOffset = "+0+0"
		fontColor = "#FFFFFFAA"
		captionOverlay = false
		overlayOnHover = true
	end sub
 
end class 


function formatColorName(pColorName)

	if isHex(pColorName) then
		formatColorName = "#" & pColorName
	else
		formatColorName = pColorName
	end if

end function