
set gxfs = new xfso

class xfso

    public function isFolder(pPath)
    
        fileExists = gfs.fileExists(pPath)
        folderExists = gfs.folderExists(pPath)    
        ret = false
        if gfs.fileExists(pPath) then
            ret = false
        elseif gfs.folderExists(pPath) then
            ret = true
        elseif gfs.getExtensionName(pPath) = "" then
            ret = true
        else
            ret = false
        end if    
        isFolder = ret
        
    end function
    

    function newFileInstance(pPath)

        nxt = pPath
        i = 0
        do until not gfs.fileExists(nxt)
            i = i + 1
            nxt = gfs.buildPath(gfs.getParentFolderName(pPath), gfs.getBaseName(pPath) & i & "." & gfs.getExtensionName(pPath))
        loop
        newFileInstance = nxt
    
    end function
    
    function newFolderInstance(pPath)

        nxt = pPath
        i = 0
        do until not gfs.folderExists(nxt)
            i = i + 1
            nxt = gfs.buildPath(gfs.getParentFolderName(pPath), gfs.getBaseName(pPath) & i)
        loop
        newFolderInstance = nxt

    end function

    function newInstance(pPath)

        if isFolder(pPath) then
            newInstance = newFolderInstance(pPath)    
        else
            newInstance = newFileInstance(pPath)
        end if

    end function

    function getParentFolderByName(pPath, pParentFolderName)

        dim fs
        set fs = createObject("Scripting.FileSystemObject")
        
        folderPath = pPath   
        do until fs.getBaseName(folderPath) = pParentFolderName or folderPath = "" 
            folderPath = fs.getParentFolderName(folderPath)   
        loop 
        
        if folderPath = pPath then folderPath = ""
        getParentFolderByName = folderPath
       
    end function 'getParentFolderByName   
  
  
    function getRandomFile(pFolder)
        
        dim f, fs
        set fs = CreateObject("Scripting.FileSystemObject")         
        set f = fs.getFolder(pFolder)
        
        Randomize
        i = CInt((Rnd() * f.Files.Count) + 1)
        j = 1 
        
        For Each fi In f.Files
           If j >= i Then 
              we "fi", fi
              Exit For
           End If
           j = j + 1
        Next

        getRandomFile = fi.path
        
    end function 'getRandomFile
  
     public sub TextFile_replaceString(pTextFile, pFind, pReplace)

        Set f = gfs.openTextFile(pTextFile, 1)

        strText = f.readAll
        f.close
        strNewText = replace(strText, pFind, pReplace)

        set f = gfs.openTextFile(pTextFile, 2)
        f.writeLine strNewText
        f.close
    
    end sub 'TextFile_replaceString

'    public function newFileInstance(pPath)
'
'        if not gfs.fileExists(pPath) then
'            f = pPath
'        else    
'            basePath = gfs.buildPath(gfs.getParentFolderName(pPath), gfs.getBaseName(pPath))
'            ext = gfs.getExtensionName(pPath)
'            i = 0
'            do
'                i = i + 1
'                f = basePath & i & "." & ext
'            loop while gfs.fileExists(f)
'        end if
'        newFileInstance = f
'
'    end function 'newFileInstance
    
    public sub wmiRename(pFilePath, pNewPath)

        fname = replace(pFilePath, "\", "\\")
        strComputer = "."
        Set objWMIService = GetObject _
            ("winmgmts:" & "!\\" & strComputer & "\root\cimv2")
        Set colFiles = objWMIService.ExecQuery _
            ("Select * from CIM_DataFile where Name = " _
                & "'" & fname & "'")
        For Each objFile in colFiles
            objfile.rename(pNewPath)
        Next    
    
    end sub
    
    public sub hideFile(pFile)
    
        set f = gfs.getFile(pFile)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if
    
    end sub
        
    public sub hideFolder(pFile)
    
        set f = gfs.getFolder(pFile)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if
    
    end sub

    function findFiles(pFolder)
    
        set dicFiles = createObject("Scripting.Dictionary")
        objStartFolder = pFolder

        Set objFolder = gfs.GetFolder(objStartFolder)
        Set colFiles = objFolder.Files
        For Each objFile in colFiles
            dicFiles.add objFile.path, ""
        Next

        ShowSubfolders gfs.GetFolder(objStartFolder)

        for each f in dicFiles
            m = m & f & vbcrlf
        next
        Set filetxt = gfs.CreateTextFile("c:\somefile3.txt", True)
        path = gfs.GetAbsolutePathName("c:\somefile3.txt")
        getname = gfs.GetFileName(path)
        filetxt.Write(m)
        filetxt.Close
        
        set findFiles = dicFiles
        
    end function
        
    Sub ShowSubFolders(Folder)
        For Each Subfolder in Folder.SubFolders
            Set objFolder = gfs.GetFolder(Subfolder.Path)
            Set colFiles = objFolder.Files
            For Each objFile in colFiles
                dicFiles.add objFile.path, ""
            Next
            ShowSubFolders Subfolder
        Next
    End Sub
    
end class 'xfso