'**** INCLUDED FILE: classes\_debug.vbs ****
dbg = 0

sub we (name, value)
    if dbg = 1 then
        wscript.echo(name & ": " & value)
    end if
end sub
'**** END INCLUDED FILE: classes\_debug.vbs ****

'**** INCLUDED FILE: classes\_global.vbs ****
' Global objects
dim gws, gfs 
set gws = CreateObject("Wscript.Shell")
set gfs = CreateObject("Scripting.FileSystemObject")

' TLB
FLD_TLBHOME = gfs.buildPath(gws.ExpandEnvironmentStrings("%PROGRAMFILES%"), "TrueLaunchBar")
FLD_TLBSKINS = gfs.buildPath(FLD_TLBHOME, "skins")

FLD_APPDATA = gws.SpecialFolders("AppData")
FLD_TLBOPTIONS = gfs.buildPath(FLD_APPDATA, "Tordex\True Launch Bar")
F_TLBOPTIONS = gfs.buildPath(FLD_TLBOPTIONS, "options.xml")

' Folders
FLD_HOME = gfs.buildPath(FLD_TLBSKINS, "M8 Tile Editor") 
FLD_TOOLBAR = gfs.buildPath(FLD_HOME, "toolbar")
FLD_SCRIPTS = gfs.buildPath(FLD_HOME, "scripts")
FLD_ICON = gfs.buildPath(FLD_TOOLBAR, "Icon")
FLD_CAPTION = gfs.buildPath(FLD_TOOLBAR, "Caption")
FLD_OVERLAY = gfs.buildPath(FLD_TOOLBAR, "Overlay")

' Hotkeys
HK_REFRESH = "^{F5}"          ' CTRL+F5
HK_TEREFRESH = "^%r"


sub createScriptWrapper(pWrapper, pScriptName)

    set f = gfs.createTextFile(pWrapper, true)

    f.writeline("<job id=""" & pScriptName & """>")
    f.writeline("   <script language=""VBScript"" src=""" & gfs.buildPath(FLD_SCRIPTS, pScriptName) & """/>")
    f.writeline("</job>")

    f.close
    
end sub 'createScriptWrapper
  
  
function isValue(obj)

    dim tmp
    on error resume next
    tmp = " " & obj
    if err <> 0 Then
        isValue = false
    else
        isValue = True
    end If
    on error goto 0

end function


function nvl(pVar, pValueIfNull)

	nvl = pVar
	if isNull(nvl) then nvl = pValueIfNull

end function


function bp(pRoot, pPath)
	bp = gfs.buildPath(pRoot, pPath)
end function
'**** END INCLUDED FILE: classes\_global.vbs ****

'**** INCLUDED FILE: classes\_CFile.vbs ****


function new_CFile(pFile)

    set new_CFile = new CFile
    new_CFile.fullpath = pFile

end function 


class CFile

    public fullpath

    public function folder
        folder = gfs.getParentFolderName(fullPath)
    end function

    public function parentFolder
        parentFolder = gfs.getParentFolderName(folder)
    end function
    	
    public function foldername
        folderName = gfs.getBaseName(folder)
    end function    
  
    public function filename
        fileName = gfs.getFileName(fullPath)
    end function

    public function name
        name = gfs.getBaseName(fullPath)
    end function

    public function extension
        extension = gfs.getExtensionName(fullPath)
    end function

    
    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "filename: " & filename & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "extension: " & extension & vbcrlf & _
                    "foldername: " & foldername & vbcrlf & _
                    "fullpath: " & fullpath

    end function 'toString

    public sub show
    
        msgbox toString, vbInformation, "CFile" 
        
    end sub 'show
       

    public function rename(pNewName)
    
        set rename = new_CFile(gfs.buildPath(folder, pNewName))
        
    end function 'rename

    public function exists
    
        fileExists = gfs.fileExists(fullPath)
        folderExists = gfs.folderExists(fullPath)
        
        exists = fileExists OR folderExists
        
    end function    

    public function isFolder
    
        fileExists = gfs.fileExists(fullPath)
        folderExists = gfs.folderExists(fullPath)    

        ret = false
        if fileExists then
            ret = false
        elseif folderExists then
            ret = true
        elseif me.extension = "" then
            ret = true
        else
            ret = false
        end if    
        
    end function
    
    public function newInstance

        set nxt = me
        i = 0
        do until not nxt.exists
            i = i + 1
            if not me.isFolder then
                set nxt = new_CFile(gfs.buildPath(me.folder, me.name & i & "." & me.extension))
            else
                set nxt = new_CFile(gfs.buildPath(me.folder, me.name & i))
            end if
        loop

        set newInstance = nxt

    end function        
    
    public sub setHidden
    
        set f = gfs.getFile(me.fullPath)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if
    
    end sub


    function getProperty(pPropertyName)
            
        Set objShell = CreateObject("Shell.Application")
        Set objFolder = objShell.Namespace(me.folder)

        i = -1
        do
            i = i + 1
            prop = objFolder.GetDetailsOf(objFolder.Items, i)
        loop until prop = pPropertyName or i > 33

        getProperty = ""
        
        For Each strFileName in objFolder.Items
            if strFileName = me.filename then
               getProperty = objFolder.GetDetailsOf(strFileName, i) 
               exit for
            end if
        next        
       
'        if prop = pPropertyName then
'            getProperty = objFolder.GetDetailsOf(me.fullpath, i)
'        else
'            getProperty = ""
'        end if    

    end function


    
'    public function fileObject
'        set fileObject = new File(fullpath)
'    end function
    
end class 'CFile    
'**** END INCLUDED FILE: classes\_CFile.vbs ****

'**** INCLUDED FILE: classes\_CString.vbs ****
public function toInt(pIn)
    ' safely converts a string to integer
    dim ret
    ret = ""
    for i = 1 to len(pIn)
        if isNumeric(mid(pIn, i, 1)) then
            ret = ret + mid(pIn, i, 1)
        end if   
    next
    toInt = cint(ret)
end function

function lft(pString, pLength)

    lft = ""
    if pLength > 0 then
        lft = left(pString, pLength)
    elseif pLength < 0 then
        lft = left(pString, len(pString) + pLength)
    end if    

end function

function ereg(strOriginalString, strPattern, varIgnoreCase)
    ' Function matches pattern, returns true or false
    ' varIgnoreCase must be TRUE (match is case insensitive) or FALSE (match is case sensitive)
    dim objRegExp : set objRegExp = new RegExp
    with objRegExp
        .Pattern = strPattern
        .IgnoreCase = varIgnoreCase
        .Global = True
    end with
    ereg = objRegExp.test(strOriginalString)
    set objRegExp = nothing
end function

function ereg_replace(strOriginalString, strPattern, strReplacement, varIgnoreCase)
    ' Function replaces pattern with replacement
    ' varIgnoreCase must be TRUE (match is case insensitive) or FALSE (match is case sensitive)
    dim objRegExp : set objRegExp = new RegExp
    with objRegExp
        .Pattern = strPattern
        .IgnoreCase = varIgnoreCase
        .Global = True
    end with
    ereg_replace = objRegExp.replace(strOriginalString, strReplacement)
    set objRegExp = nothing
end function

function isHex(pValue)

	isHex = not ereg(pValue, "[^a-f0-9\s]", True)

end function

'**** END INCLUDED FILE: classes\_CString.vbs ****

'**** INCLUDED FILE: classes\_CToolbar.vbs ****

'#USES classes\_CMenu.vbs
'#USES classes\_CItem.vbs
'**** INCLUDED FILE: classes\_CINIFile.vbs ****
class CINIFile

    public aFile
    private lastIndex
    
    sub load(pINIFile)

        set fs = createObject("Scripting.FileSystemObject")    
        set file = fs.openTextFile( pINIFile, 1, True )
        aFile = split(file.readAll(), vbCRLF)    
        file.close
        
    end sub


    sub save(pINIFile)

        set fs = createObject("Scripting.FileSystemObject")    
        set file = fs.openTextFile(pINIFile, 2, false)
        sFile = join(aFile, vbCRLF)
        file.write(sFile)
        file.close
        
    end sub

    
    function getKeyValue(pSection, pKey)
    
        index = findKey(pSection, pKey)
        
        splitLine = split(aFile(index), "=")
        getKeyValue = ""
        if lcase(trim(splitLine(0))) = lcase(trim(pKey)) then
            getKeyValue = splitLine(1)
        end if    

    end function 'getKeyValue


    function getKeys(pKey)
    
        set getKeys = createObject("Scripting.Dictionary")
        
        for each line in aFile
            trimmedLine = trim(line)
            if NOT trimmedLine = "" then
                splitLine = split(trimmedLine, "=")
                if lcase(trim(splitLine(0))) = lcase(trim(pKey)) then
                    if not getKeys.exists(splitLine(1)) then
                        getKeys.add splitLine(1), ""
                    end if    
                end if    
            end if
        next
        
    end function 'getKeys
    

    
    function findKey(pSection, pKey)

        ' returns the line number of the found key, 0 if the keys does not exist
        ' and -1 if the section does not exist.
        
        ret = 0
        sectionFound = false
        index = -1
        for each line in aFile
            
            index = index + 1    
            trimmedLine = trim(line)             
            
            if NOT sectionFound then
          
                if replace(lcase(trimmedLine), lcase(pSection), "") = "[]" then
                    sectionFound = true
                end if    

            else
                
                if left(trimmedLine, 1) = "[" then
                    exit for
                else
                    splitLine = split(trimmedLine, "=")
                    
                    if ubound(splitLine) > -1 then
                        if lcase(trim(splitLine(0))) = lcase(pKey) then
                            ret = index
                            exit for
                        end if    
                    end if
                end if
            end if

        next

        lastIndex = index

        if not sectionFound then
            ret = -1
        end if    
            
        findKey = ret

    end function

    sub setKeyValue(pSection, pKey, pValue)
    
        index = findKey(pSection, pKey)
        if index > 0 then 
            splitLine = split(aFile(index), "=")
            if lcase(trim(splitLine(0))) = lcase(trim(pKey)) then
                aFile(index) = splitLine(0) & "=" & pValue
            end if
        else
       
            if index = -1 then
                ubnd = ubound(aFile) + 2
                redim preserve aFile(ubnd)
                aFile(ubnd-1) = "[" & pSection & "]"
                aFile(ubnd) = pKey & "=" & pValue
                
            else 
                ubnd = ubound(aFile)
                redim preserve aFile(ubnd + 1)
                for i = ubnd to lastIndex + 1 step -1
                    aFile(i+1) = aFile(i) 
                next
                aFile(lastIndex+1) = pKey & "=" & pValue
            end if   
                
        end if            
    
    end sub 'setKeyValue

    
    public function findSections(pSection)
    
        set findSections = CreateObject("Scripting.Dictionary")
        
        for each line in aFile
            trimmedLine = trim(line)
            if left(trimmedLine, len(pSection) + 1) = "[" & pSection then
                findSections.add mid(trimmedLine, 2, len(trimmedLine) - 2), ""
            end if
        next        

    end function
    
    function getSection(pSection)
    
        set getSection = createObject("Scripting.Dictionary")
        
        start = false
        for each line in aFile
            trimmedLine = trim(line)
            if start then
                if left(trimmedLine, 1) = "[" then
                    exit for
                end if
                if not trimmedLine = "" then
                    splitLine = split(trimmedLine, "=")
                    getSection.add splitLine(0), splitLine(1)
                 end if   
            end if
            if trimmedLine = "[" & pSection & "]" then
                start = true
            end if
        next
        
    end function

    
    public function nextSectionInstance(pSection)
    
        set sections = findSections(pSection)
        nextInstance = 0
        for each section in sections
            instance = replace(section, pSection, "")
            if isNumeric(instance) then
                if instance > nextInstance then
                    nextInstance = instance + 1
                end if
            end if
        next

        nextSectionInstance = pSection & nextInstance

                        
    end function    
              
    
    
    private sub Class_Initialize
        lastIndex = 0
    end sub

    
end class 'CINIFile


'**** END INCLUDED FILE: classes\_CINIFile.vbs ****

'#USES classes\_CWorkSpace.vbs



function new_CToolbar(pPath)

    set this = new CToolbar
    this.folder = pPath
    this.name = gfs.getBaseName(this.folder)
    this.tlbdata = gfs.buildPath(this.folder, "tlbdata.xml")
    this.setup = gfs.buildPath(this.folder, "setup.ini")
    this.images = gfs.buildPath(this.folder, "~~images~~")
    this.btnImages = gfs.buildPath(this.images, "btnimages")
    this.icons = gfs.buildPath(this.images, "icons")
    this.overlays = gfs.buildPath(this.images, "overlays") 
    set new_CToolbar = this

end function 'new_CToolbar

class CToolbar

    public name
    public folder
    public tlbdata
    public setup
    public images
    public btnImages
    public icons
    public overlays

    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "tlbdata: " & tlbdata & vbcrlf & _
                    "setup: " & setup & vbcrlf & _
                    "images: " & images & vbcrlf & _
                    "btnImages: " & btnImages & vbcrlf & _
                    "icons: " & icons & vbcrlf & _
                    "overlays: " & overlays

    end function 'toString

    public sub show(pInstanceName)
    
        msgbox toString, vbInformation, pInstanceName & " (instance of CToolbar)" 
        
    end sub 'show

    public sub create
    
        gfs.createFolder(folder)
        gfs.createFolder(images)
        gfs.createFolder(btnimages)
        gfs.createFolder(icons)
        set otlbdata = new_CTLBData(tlbdata)
        otlbdata.save
        set tlboptions = load_CTLBData(F_TLBOPTIONS)
        set toolbarsNode = tlboptions.xmldoc.selectSingleNode("truelaunchbar/toolbars")

        set nums = createObject("Scripting.Dictionary")        
        for each toolbar in toolbarsNode.childNodes
            split1 = split(toolbar.getAttribute("name"), ". MetroTLB ")
            if ubound(split1) = 1 then
               if isNumeric(split1(0)) then
                    n = int(split1(0))
                    if not nums.exists(n) then
                        nums.add n, split1(1)
                    end if    
                end if
            end if
        next
        
        i = 1
        do until not nums.exists(i)
            i = i + 1
        loop
            
'        msgbox i
        set toolbarElement = tlboptions.xmlDoc.createElement("toolbar")
        toolbarElement.setAttribute "name", i & ". MetroTLB " & name            
        toolbarElement.setAttribute "path", folder    
        toolbarsNode.appendChild(toolbarElement)
        tlboptions.save
        gfs.copyFile gfs.buildPath(FLD_TOOLBARS, "setup.ini"), folder & "\"

    end sub
    
    public function getHotKey
    
            set ox = load_CTLBData(F_TLBOPTIONSXML)
            set tb=ox.xmlDoc.selectSingleNode("truelaunchbar/toolbars/toolbar[contains(@name, 'MetroTLB " & itemBaseName & "')]")
            msgbox tb.getAttribute("name")
    end function    
    
    
end class    
    
'**** END INCLUDED FILE: classes\_CToolbar.vbs ****

'**** INCLUDED FILE: classes\_CTileImage.vbs ****


'**** INCLUDED FILE: classes\_CPoint.vbs ****
public function toInt(pIn)
    ' safely converts a string to integer
    dim ret
    ret = ""
    for i = 1 to len(pIn)
        if isNumeric(mid(pIn, i, 1)) then
            ret = ret + mid(pIn, i, 1)
        end if   
    next
    toInt = cint(ret)
end function



public function new_CPoint(xy)

    xxy = replace(xy, " ", "")
    point = split(xxy, "x")
    set this = new CPoint
    this.x = toInt(point(0)) ' had issues with CINT here so uses custom toInt instead
    this.y = toInt(point(1))
    
    set new_CPoint = this
    
end function

class CPoint

    public x
    public y

    public function toString

        toString = x & "x" & y
        
    end function
 
    private sub Class_Initialize
        x = 0
        y = 0
    end sub
 
end class
'**** END INCLUDED FILE: classes\_CPoint.vbs ****


class CTileImage

	public tileSize
	public effect
	
	public iconPath
	public iconSize
	public iconPosition
	public iconOpacity

	public captionText
	public captionPosition
	public captionShow
	public captionFontSize
	public captionFontColor

	public overlayText
	public overlayPosition
	public overlayShow
	public overlayFontSize
	public overlayFontColor
	public overlayBackgroundColor

	public backgroundImagePath
	public path

	
	public sub setIconSize(pSize)
	
		select case pSize
			case "Full"
				iconSize = "120x120"
			case "Big"
				iconSize = "96x96"				
			case "Original"
				iconSize = "100%"
			case "Small"
				iconSize = "48x48"
			case "Smaller"
				iconSize = "32x32"
			case "Oversized"
				iconSize = "192x192"
			case else 
				iconSize = "64x64"
		end select
			
	end sub
	
    public function create

        dim img 
        dim msgs

		if tileSize = "Larger" then
			set dims = new_CPoint("248x120")	
			style = gfs.buildPath(FLD_TOOLBAR, "~~images~~\styles\metro-big.png")
		else
			set dims = new_CPoint("120x120")		
			style = gfs.buildPath(FLD_TOOLBAR, "~~images~~\styles\metro.png")
		end if
		
		if captionShow = "Never" then
			captionNormal = "mpr:blank"
			captionHover = "mpr:blank"
		elseif captionShow = "On hover" then
			captionNormal = "mpr:blank"
			captionHover = "mpr:caption"
		else
			captionNormal = "mpr:caption"
			captionHover = "mpr:caption"
		end if

		if overlayShow = "Never" then
			overlayNormal = "mpr:blank"
			overlayHover = "mpr:blank"
		elseif overlayShow = "On hover" then
			overlayNormal = "mpr:blank"
			overlayHover = "mpr:overlay"
		else
			overlayNormal = "mpr:overlay"
			overlayHover = "mpr:overlay"
		end if

        set img = createObject("ImageMagickObject.MagickImage.1")

		opacity = iconOpacity / 100

		set bgipf = new_CFile(backgroundImagePath)
		bgipbig = gfs.buildPath(bgipf.folder, bgipf.name & "-big." & bgipf.extension)
		if gfs.fileExists(bgipbig) then
			bgip = bgipbig
		else
			bgip = backgroundImagePath
		end if	

		ao = getEffectDef(effect)
		if ubound(ao) = -1 then
			ao = array("-resize", dims.x + 4 & "x" & dims.y + 4 & "!", "-bordercolor", "none", "-border", "2")
		end if

        msgs = img.convert(style, "-shave", "4x4", _
						   "-write", "mpr:style", "+delete", _
						   _
						   "-size", dims.toString, "xc:transparent", _ 
						   "-write", "mpr:blank", "+delete", _							   
						   _
						   bgip, "-resize", dims.toString & "!", _
						   "-write", "mpr:color", "+delete", _
						   _
						   "mpr:color", "mpr:style", "-composite",  _	
						   "-write", "mpr:bg", "+delete", _
						   _
						   iconPath, "-trim", "-resize", iconSize, _
						   "-channel", "Alpha", "-evaluate", "Multiply", opacity, _ 						   
						   "-bordercolor", "none", "-border", "8x4", _
						   "-write", "mpr:icon", "+delete", _ 
						   _
						   "-font", "Segoe-UI-Bold", "-pointsize", captionFontSize, "-fill", captionFontColor, _
						   "-background", "none", "-size", dims.x - 16 & "x", _
						   "-bordercolor", "#00000000", "-border", "8x4", _
						   "-gravity", captionPosition, "caption:" & captionText, _
						   "-write", "mpr:caption", "+delete", _
						   _
						   "-font", "Segoe-UI-Bold", "-pointsize", overlayFontSize, "-fill", overlayFontColor, _
						   "-background", "none", "-size", dims.x - 16 & "x", _
						   "-bordercolor", overlayBackgroundColor, "-border", "8x4", _
						   "-gravity", overlayPosition, "caption:" & overlayText, _
						   "-write", "mpr:overlay", "+delete", _ 
						   _
						   "mpr:bg", "mpr:icon", "-gravity", iconPosition, "-composite", _
						   "-write", "mpr:base", _
						   captionNormal, "-gravity", captionPosition, "-composite", _
						   overlayNormal, "-gravity", overlayPosition, "-composite", _
						   "-write", "mpr:normal", "+delete", _
						   _
						   "mpr:base", _
						   captionHover, "-gravity", captionPosition, "-composite", _
						   overlayHover, "-gravity", overlayPosition, "-composite", _
						   "-bordercolor", "none", "-border", "4", _
						   style, "-gravity", "center", "-composite", _
						   "-write", "mpr:hover", _						   
						   _
						   ao(0), ao(1), ao(2), ao(3), ao(4), ao(5), _
                           "-write", "mpr:active", "+delete", _						   
							_
						   "-bordercolor", "none", "-border", "4", _ 
						   "mpr:normal", _
						   "-bordercolor", "none", "-border", "0", _
						   "mpr:active", "mpr:hover", "-append", path)						   

'						   "-resize", dims.x + 4 & "x" & dims.y + 4 & "!", "-bordercolor", "none", "-border", "2", _

		
        we "msgs1", msgs

        if msgs = "128,384,PNG" then
            create = true 
        end if
                
    end function 'create

	function getEffectDef(pEffect)

        set effectDict = createObject("Scripting.Dictionary")
		
		effectDict.add "Tilt right", array("-matte", "-virtual-pixel", "transparent", "-distort", "Perspective", "0.5,0 0.5,0  0.5,128  0.5,128  128,128 124,124  128,0 124,4")
		effectDict.add "Tilt left", array("-matte", "-virtual-pixel", "transparent", "-distort", "Perspective", "127.5,0 127.5,0  127.5,128  127.5,128  0,128 4,124 0,0 4,4")
		effectDict.add "Tilt down", array("-matte", "-virtual-pixel", "transparent", "-distort", "Perspective", "0,0.5 0,0.5  128,0.5  128,0.5  128,128 124,124  0,128 4,124")
		effectDict.add "Tilt up", array("-matte", "-virtual-pixel", "transparent", "-distort", "Perspective", "0,127.5 0,127.5  128,127.5  128,127.5  128,0 124,4  0,0 4,4")
		
		nullArray = array()
		
		if pEffect = "Random" then
			effectDictItems = effectDict.keys
			randomize
			i = int((effectDict.count)*rnd())
			lEffect = effectDictItems(i)
			effectArray = effectDict(lEffect)
		elseif effectDict.exists(pEffect) then
			effectArray =  effectDict(pEffect)
		else
			effectArray = nullArray
		end if
		
		getEffectDef = effectArray 

	end function		
	
    public function toString

		toString =  "iconPath: " & iconPath & vbcrlf & _
					"iconSize: " & iconSize & vbcrlf & _
					"iconPosition: " & iconPosition & vbcrlf & _
					"iconOpacity: " & iconOpacity & vbcrlf & _
					"captionText: " & captionText & vbcrlf & _
					"captionPosition: " & captionPosition & vbcrlf & _
					"captionShow: " & captionShow & vbcrlf & _
					"captionFontSize: " & captionFontSize & vbcrlf & _
					"captionFontColor: " & captionFontColor & vbcrlf & _
					"overlayText: " & overlayText & vbcrlf & _
					"overlayPosition: " & overlayPosition & vbcrlf & _
					"overlayShow: " & overlayShow & vbcrlf & _
					"overlayFontSize: " & overlayFontSize & vbcrlf & _
					"overlayFontColor: " & overlayFontColor & vbcrlf & _
					"overlayBackgroundColor: " & overlayBackgroundColor & vbcrlf & _					
					"backgroundImagePath: " & backgroundImagePath & vbcrlf & _
					"path: " & path & vbcrlf
					
    end function 'toString

    public sub show
    
        msgbox toString, vbInformation, "CTileImage" 
        
    end sub 'show

    public sub show2(pTitle)
    
        msgbox toString, vbInformation, pTitle 
        
    end sub 'show
	
	private sub Class_Initialize

		tileSize = "Smaller"
		iconSize = "normal"
		iconPosition = "center"
		iconOpacity = 100
		iconOffset = "+0+0"
		captionPosition = "southwest"
		caption = "Untitled"
		captionOffset = "+0+0"
		fontColor = "#FFFFFFAA"
		captionOverlay = false
		overlayOnHover = true
	end sub
 
end class 


function formatColorName(pColorName)

	if isHex(pColorName) then
		formatColorName = "#" & pColorName
	else
		formatColorName = pColorName
	end if

end function
'**** END INCLUDED FILE: classes\_CTileImage.vbs ****

'**** INCLUDED FILE: classes\_CFileVar.vbs ****
function new_CFileVar(pFolder, pName, pValue)

    set new_CFileVar = new CFileVar
	new_CFileVar.folder = pFolder
    new_CFileVar.name = pName
	new_CFileVar.setValue pValue

end function 

function get_CFileVar(pFolder, pName)

    set get_CFileVar = new CFileVar
	get_CFileVar.folder = pFolder
    get_CFileVar.name = pName
	get_CFileVar.value = empty
	
	set varFile = get_CFileVar.getVarFile

	if not varFile is nothing then
		varFileName = varFile.name
		split1 = split(varFileName, "[")
		if ubound(split1) = 1 then
			split2 = split(split1(1), "]")
			get_CFileVar.value = split2(0)	
		end if
	end if	
	
end function 


class CFileVar

	public name
	
	public value
	
	public folder

	public function getVarFile
	
		set getVarFile = nothing
		set fld = gfs.getFolder(folder)

		for each f in fld.subFolders
			if NOT instr(f.name, name & " [") = 0 then
				set getVarFile = gfs.getFolder(f.path)
				exit for
			end if	
		next
		
		if getVarFile is nothing then
			for each f in fld.files
				if NOT instr(f.name, name & " [") = 0 then	
					set getVarFile = gfs.getFile(f.path)
					exit for
				end if	
			next
		end if	
		
	end function

	public sub hide
	
		set f = gfs.getFolder(fullpath)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if

	end sub
	
	public function fullPath
	
		fullPath = gfs.buildPath(folder, name & " [" & value & "]")
		
	end function

	public sub setValue(pValue)
		
		value = pValue
		set varFile = getVarFile

		if not varFile is nothing then
			ext = gfs.getExtensionName(varFile.path)
			if not ext = "" then
				if not gfs.fileExists(fullPath & "." & ext) then
				    done = false
					timer1 = 0
					do
						on error resume next
						varFile.name = gfs.getBaseName(fullPath) & "." & ext
						if err.number = 0 then
							done = true
							on error resume next
						else	
							wscript.sleep 100
							timer1 = timer1 + 100
						end if
					loop until done or timer1 > 2000		
				end if	
			else
				if not gfs.folderExists(fullPath) then
				    done = false
					timer2 = 0
					do
						on error resume next
						varFile.name = gfs.getBaseName(fullPath) & "." & ext
						if err.number = 0 then
							done = true
							on error resume next
						else	
							wscript.sleep 100
							timer2 = timer2 + 100
						end if
					loop until done or timer2 > 2000
				end if
			end if	
		end if	

	end sub
 
    
    
    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "value: " & value & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "fullpath: " & fullpath

    end function

    public sub show
    
        msgbox toString, vbInformation, "CFileVar" 
        
    end sub
	
end class 
'**** END INCLUDED FILE: classes\_CFileVar.vbs ****

'**** INCLUDED FILE: classes\_CTLBData.vbs ****
'**** INCLUDED FILE: classes\_xfso.vbs ****

set gxfs = new xfso

class xfso

    public function isFolder(pPath)
    
        fileExists = gfs.fileExists(pPath)
        folderExists = gfs.folderExists(pPath)    
        ret = false
        if gfs.fileExists(pPath) then
            ret = false
        elseif gfs.folderExists(pPath) then
            ret = true
        elseif gfs.getExtensionName(pPath) = "" then
            ret = true
        else
            ret = false
        end if    
        isFolder = ret
        
    end function
    

    function newFileInstance(pPath)

        nxt = pPath
        i = 0
        do until not gfs.fileExists(nxt)
            i = i + 1
            nxt = gfs.buildPath(gfs.getParentFolderName(pPath), gfs.getBaseName(pPath) & i & "." & gfs.getExtensionName(pPath))
        loop
        newFileInstance = nxt
    
    end function
    
    function newFolderInstance(pPath)

        nxt = pPath
        i = 0
        do until not gfs.folderExists(nxt)
            i = i + 1
            nxt = gfs.buildPath(gfs.getParentFolderName(pPath), gfs.getBaseName(pPath) & i)
        loop
        newFolderInstance = nxt

    end function

    function newInstance(pPath)

        if isFolder(pPath) then
            newInstance = newFolderInstance(pPath)    
        else
            newInstance = newFileInstance(pPath)
        end if

    end function

    function getParentFolderByName(pPath, pParentFolderName)

        dim fs
        set fs = createObject("Scripting.FileSystemObject")
        
        folderPath = pPath   
        do until fs.getBaseName(folderPath) = pParentFolderName or folderPath = "" 
            folderPath = fs.getParentFolderName(folderPath)   
        loop 
        
        if folderPath = pPath then folderPath = ""
        getParentFolderByName = folderPath
       
    end function 'getParentFolderByName   
  
  
    function getRandomFile(pFolder)
        
        dim f, fs
        set fs = CreateObject("Scripting.FileSystemObject")         
        set f = fs.getFolder(pFolder)
        
        Randomize
        i = CInt((Rnd() * f.Files.Count) + 1)
        j = 1 
        
        For Each fi In f.Files
           If j >= i Then 
              we "fi", fi
              Exit For
           End If
           j = j + 1
        Next

        getRandomFile = fi.path
        
    end function 'getRandomFile
  
     public sub TextFile_replaceString(pTextFile, pFind, pReplace)

        Set f = gfs.openTextFile(pTextFile, 1)

        strText = f.readAll
        f.close
        strNewText = replace(strText, pFind, pReplace)

        set f = gfs.openTextFile(pTextFile, 2)
        f.writeLine strNewText
        f.close
    
    end sub 'TextFile_replaceString

'    public function newFileInstance(pPath)
'
'        if not gfs.fileExists(pPath) then
'            f = pPath
'        else    
'            basePath = gfs.buildPath(gfs.getParentFolderName(pPath), gfs.getBaseName(pPath))
'            ext = gfs.getExtensionName(pPath)
'            i = 0
'            do
'                i = i + 1
'                f = basePath & i & "." & ext
'            loop while gfs.fileExists(f)
'        end if
'        newFileInstance = f
'
'    end function 'newFileInstance
    
    public sub wmiRename(pFilePath, pNewPath)

        fname = replace(pFilePath, "\", "\\")
        strComputer = "."
        Set objWMIService = GetObject _
            ("winmgmts:" & "!\\" & strComputer & "\root\cimv2")
        Set colFiles = objWMIService.ExecQuery _
            ("Select * from CIM_DataFile where Name = " _
                & "'" & fname & "'")
        For Each objFile in colFiles
            objfile.rename(pNewPath)
        Next    
    
    end sub
    
    public sub hideFile(pFile)
    
        set f = gfs.getFile(pFile)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if
    
    end sub
        
    public sub hideFolder(pFile)
    
        set f = gfs.getFolder(pFile)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if
    
    end sub

    function findFiles(pFolder)
    
        set dicFiles = createObject("Scripting.Dictionary")
        objStartFolder = pFolder

        Set objFolder = gfs.GetFolder(objStartFolder)
        Set colFiles = objFolder.Files
        For Each objFile in colFiles
            dicFiles.add objFile.path, ""
        Next

        ShowSubfolders gfs.GetFolder(objStartFolder)

        for each f in dicFiles
            m = m & f & vbcrlf
        next
        Set filetxt = gfs.CreateTextFile("c:\somefile3.txt", True)
        path = gfs.GetAbsolutePathName("c:\somefile3.txt")
        getname = gfs.GetFileName(path)
        filetxt.Write(m)
        filetxt.Close
        
        set findFiles = dicFiles
        
    end function
        
    Sub ShowSubFolders(Folder)
        For Each Subfolder in Folder.SubFolders
            Set objFolder = gfs.GetFolder(Subfolder.Path)
            Set colFiles = objFolder.Files
            For Each objFile in colFiles
                dicFiles.add objFile.path, ""
            Next
            ShowSubFolders Subfolder
        Next
    End Sub
    
end class 'xfso
'**** END INCLUDED FILE: classes\_xfso.vbs ****



'**** INCLUDED FILE: classes\_CFolder.vbs ****


function new_CFolder(pFile)

    set new_CFolder = new CFolder
    new_CFolder.path = pFile

end function 'create


class CFolder

    public path

    public function name
        name = gfs.getBaseName(path)
    end function
    
    public sub write

        wscript.echo(toString)
        
    end sub 'write
    
    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "path: " & path

    end function 'toString

    
    public function exists
    
        exists = gfs.folderExists(fullPath)
        
    end function    

    
    public sub create
    
        gfs.createFolder(path)
    
    end sub
 
    
    public function findFiles

        set objFSO = createObject("Scripting.FileSystemObject")
        set dicFiles = createObject("Scripting.Dictionary")
       
        set objFolder = objFSO.getFolder(path)
        set colFiles = objFolder.Files
        for each objFile in colFiles
            dicFiles.add objFile.path, ""
            msgbox "objFile:" & objFile.path
        next

        set colFolders = objFolder.subFolders
        for each objSubFolder in colFolders
        msgbox objSubFolder.path
            set subFolder = new_CFolder(objSubFolder.path)
            set dicSubFolderFiles = subFolder.findFiles
            for each subFolderFile in dicSubFolderFiles
                msgbox "XxXX" & subFolderFile.path
                dicFiles.add subFolderFile.path , ""
            next
            set subFolder = nothing
        next
    
        set findFiles = dicFiles
        
    end function 'findFiles



    
    
end class 'CFolder    
'**** END INCLUDED FILE: classes\_CFolder.vbs ****



public function new_CTLBData(ptlbdata)

        set new_CTLBData = new CTLBData  

        new_CTLBData.xmlDoc.loadXML("<?xml version=""1.0"" encoding=""utf-8""?>" & vbCRLF & _
            "<tlbdata>" & vbCRLF & _
            "    <folder name="""">" & vbCRLF & _
            "        <layout>" & vbCRLF & _
            "        </layout>" & vbCRLF & _
            "        <options skin="""" fontNameMI="""" fontSizeCAP=""0"" fontNameCAP="""" fontSizeTIT=""0"" fontNameTIT="""" disableGlass=""0"" disableTips=""0"" overlayFileName="""" overlayFlags=""34"" overlayTransparency=""255"" filterShowMask="""" filterHideMask=""""/>" & vbCRLF & _
            "    </folder>" & vbCRLF & _
            "</tlbdata>")        

        set new_CTLBData.options=new_CTLBData.xmlDoc.selectSingleNode("tlbdata/folder/options")     
      
        new_CTLBData.xmlDocPath = ptlbdata
            
end function


public function load_CTLBData(ptlbdata) 

    set load_CTLBData = new CTLBData
    load_CTLBData.load(ptlbdata)         
    load_CTLBData.xmlDocPath = ptlbdata
     
end function  
    

    

class CTLBData

    public function newItem(pName)
    
        set element = xmlDoc.createElement("item")
        element.setAttribute "name", pName    

        set newItem = element    

    end function
    
'   ** Public Methods

    public sub save
		on error resume next
        xmlDoc.save(xmlDocPath)
		on error goto 0
    end sub

    public sub saveAs(pFile)
		on error resume next
        xmlDoc.save(pFile)
		on error goto 0
    end sub
    
  
    function findItemByName(pItemName)
        set findItemByName=xmlDoc.selectSingleNode("//layout/item[@name='" & pItemName & "']")        
    end function

    public function getItemAttribute(pItemName, pAttribute)

        set itemNode=findItemByName(pItemName)
		if not itemNode is nothing then
			getItemAttribute = itemNode.getAttribute(pAttribute)
		end if
    end function

    public function getItemImagePath(pItemName)
        
        getItemImagePath = getItemAttribute(pItemName, "ImagePath")
    
    end function

    
    public sub setOption(pOptionName, pValue)
        
        set optionsNode=xmlDoc.selectSingleNode("tlbdata/folder/options")      
        optionsNode.setAttribute pOptionName, pValue
    
    end sub

    public function getOption(pOptionName)
        
        set optionsNode=xmlDoc.selectSingleNode("tlbdata/folder/options")      
        getOption = optionsNode.getAttribute(pOptionName)
        
    end function
   
    public function getOptions
        
        set getOptions=xmlDoc.selectSingleNode("tlbdata/folder/options")      
        
    end function
     
   
    public function toggleOption(pOptionName)
        
        curval = getOption(pOptionName)
        if curval = "1" then
            nxtval = "0"
        else
            nxtval = "1"
        end if
        setOption pOptionName, nxtval

    end function
      
    
    
    public sub setItemAttribute(pItemName, pAttribute, pValue)
        
        set itemNode=findItemByName(pItemName)
		if not itemNode is nothing then		
			itemNode.setAttribute pAttribute, pValue
		end if
		
    end sub

    public sub setItemImagePath(pItemName, pValue)

        setItemAttribute pItemName, "ImagePath", pValue

    end sub
    
    public sub setCaption(pItemName, pValue)

        set itemNode=findItemByName(pItemName)  
        itemNode.setAttribute "showCaption", "2"    
        set captionNode = xmlDoc.createElement("caption")
        set captionText = xmlDoc.createTextNode(pValue)
        captionNode.appendChild(captionText)
        itemNode.appendChild(captionNode)
       
    end sub
    
    public sub setIconLocation(pItemName, pValue)

        set itemNode=findItemByName(pItemName)  
        set captionNode = xmlDoc.createElement("IconLocation")
        set captionText = xmlDoc.createTextNode(pValue)
        captionNode.appendChild(captionText)
        itemNode.appendChild(captionNode)
       
    end sub
    
    public function getChildText(pItemName, pElementName)
        
        getChildText = ""
        dim itemNode
        set itemNode=findItemByName(pItemName)
		if not itemNode is nothing then
			for each node in itemNode.childNodes
				if node.nodeName = pElementName then
					getChildText = node.text
				end if
			next           
        end if
		
    end function
        
    public sub removeCaption(pItemName)

        set itemNode=findItemByName(pItemName)  
        set childNodes = itemNode.childNodes
        itemNode.setAttribute "showCaption", "0"
         
        for each childNode in childNodes 
            if childNode.nodeName = "caption" then
                itemNode.removeChild(childNode)
            end if     
        next
   
    end sub

    public sub removeDescription(pItemName)

        set itemNode=findItemByName(pItemName)  
        set childNodes = itemNode.childNodes
        itemNode.setAttribute "showDescription", "0"
         
        for each childNode in childNodes 
            if childNode.nodeName = "description" then
                itemNode.removeChild(childNode)
            end if     
        next
   
    end sub

    public sub removeChild(pItemName, pChildName)

        set itemNode=findItemByName(pItemName)  
        set childNodes = itemNode.childNodes
         
        for each childNode in childNodes 
            if childNode.nodeName = pChildName then
                itemNode.removeChild(childNode)
            end if     
        next
   
    end sub
        
	
    public sub hideItem(pItemName)

        setItemAttribute pItemName, "hidden", "1"
        
    end sub

    public sub showItem(pItemName)

        setItemAttribute pItemName, "hidden", "0"
     
    end sub

    public sub load(ptlbdata) 

        dim	counter
		counter = 0
		do while not xmlDoc.Load(ptlbdata) and counter < 1000
			wscript.sleep 50
			counter = counter + 50
		loop	
        xmlDocPath = ptlbdata
         
    end sub  
    
'   ** Public Properties
    
    public xmlDoc
    public xmlDocPath
    public options
    
'   ** Private Methods

    private sub Class_Initialize()
    
        set xmlDoc = createObject("Microsoft.XMLDOM")
        xmlDoc.Async = false
        xmlDoc.setProperty "SelectionLanguage", "XPath"
        
    end sub


    public function createItem(pItemName)

        set lItem = xmlDoc.createElement("item")
        lItem.setAttribute "name", pItemName
        set layoutNode = xmldoc.selectSingleNode("tlbdata/folder/layout")
        set createItem = layoutNode.appendChild(lItem)        

    end function
    
    public function appendItem(pXMLElement)

        set layoutNode = xmldoc.selectSingleNode("tlbdata/folder/layout")
        set appendItem = layoutNode.appendChild(pXMLElement)        

    end function
        
    
    
    public function createItemElement(pItemName)

        set createItemElement = xmlDoc.createElement("item")
        createItemElement.setAttribute "name", pItemName
'        set layoutNode = xmldoc.selectSingleNode("tlbdata/folder/layout")
'        set createItem = layoutNode.appendChild(newItem)        

    end function
        
    
    public function createItem2(pItemName, pImagePath)

        set newItem = xmlDoc.createElement("item")
        newItem.setAttribute "name", pItemName
        newItem.setAttribute "ImagePath", pImagePath
        set layoutNode = xmldoc.selectSingleNode("tlbdata/folder/layout")
        layoutNode.appendChild(newItem)        
        set createItem2 = newItem
        
        
    end function
    
    public sub createCaption(pNode, pCaptionText)
        
        dim newItem
        set newItem = xmlDoc.createElement("caption")
        newItem.text = pCaptionText
        pNode.appendChild(newItem)
        
    end sub

    public sub appendChildTextNode(pNode, pTextNodeName, pText)

        dim newItem
        set newItem = xmlDoc.createElement(pTextNodeName)
        newItem.text = pText
        pNode.appendChild(newItem)
       
    end sub

    
    public function createItemInstance(pItemName, pImagePath)

        itemBaseName = gfs.getBaseName(pItemName)
        itemExtension = gfs.getExtensionName(pItemName)
        set itemNodes = xmlDoc.selectNodes("//layout/item[contains(@name, '" & itemBaseName & "')]")

        usedItems = ""
        for each node in itemNodes
            usedItems = usedItems & "," & node.getAttribute("name")
        next
        
        i = 1
      
        do
            if itemExtension = "" then
                itemName = itemBaseName & i
            else
                itemName = itemBaseName & i & "." & itemExtension
            end if
            i = i + 1
        loop while instr(usedItems, itemName)

        set createItemInstance = createItem3(itemName, pImagePath, false)
        save

    end function 'createItemInstance
         
    function getIconLocation(pItemName)
        
		getIconLocation = ""   
        getIconLocation = getChildText(pItemName, "IconLocation")
    
    end function

end class 'CTLBDATA
'**** END INCLUDED FILE: classes\_CTLBData.vbs ****


	
set script = new_CFile(wscript.scriptFullName)
set toolbar = new_CToolbar(FLD_TOOLBAR)
set tlbdata = load_CTLBData(toolbar.tlbdata)
set tileImage = new CTileImage

iconLoc = tlbdata.getIconLocation("Tile.lnk")
if not iconLoc = "" then
	if iconLoc = gfs.getFileName(iconLoc) then
		iconLoc = gfs.buildPath(toolbar.icons, iconLoc)
	end if	
	tileImage.iconPath = iconLoc
else
	tileImage.iconPath = gfs.buildPath(toolbar.icons, "icon.png")
end if

tileImage.path = gfs.buildPath(toolbar.btnImages, "btnImage.png")

set tileSizeVar = get_CFileVar(toolbar.folder, "Tile Size")
set sc = gws.createShortcut(gfs.buildPath(toolbar.folder, "Tile Size.lnk"))
set image = new_CFile(gfs.buildPath(toolbar.btnImages, "tilesize.png"))

if tileSizeVar.value = "Smaller" then
	sc.description = "Larger"
	set newImage = new_CFile(gfs.buildPath(toolbar.btnImages, "larger.png"))	
else
	sc.description = "Smaller"
	set newImage = new_CFile(gfs.buildPath(toolbar.btnImages, "smaller.png"))
end if
gfs.copyFile newImage.fullpath, image.fullPath, true
sc.save

'Tile
set fvar = get_CFileVar(FLD_ICON, "Size")
tileImage.setIconSize (fvar.value)

set fvar = get_CFileVar(toolbar.folder, "Tile Color")
tileImage.backgroundImagePath = gfs.buildPath(gfs.buildPath(toolbar.icons, "backgrounds"), fvar.value & ".png")

set fvar = get_CFileVar(FLD_TOOLBAR, "Effect")
tileImage.effect = fvar.value
'End Tile

'Icon
set fvar = get_CFileVar(FLD_ICON, "Position")
tileImage.iconPosition = fvar.value

set fvar = get_CFileVar(FLD_ICON, "Opacity")
tileImage.iconOpacity = fvar.value
'End Icon

'Caption
set captionTLBData = load_CTLBData(gfs.buildPath(FLD_CAPTION, "tlbdata.xml"))
tileImage.captionText = captionTLBData.getItemAttribute("Text.vbs", "leftText")
tileImage.captionFontColor = formatColorName(captionTLBData.getItemAttribute("Font Color.vbs", "leftText"))
set captionTLBData = nothing

set fvar = get_CFileVar(FLD_CAPTION, "Position")
tileImage.captionPosition = fvar.value

set fvar = get_CFileVar(FLD_CAPTION, "Show")
tileImage.captionShow = fvar.value

set fvar = get_CFileVar(FLD_CAPTION, "Font Size")
tileImage.captionFontSize = fvar.value
'End Caption

'Overlay
set overlayTLBData = load_CTLBData(gfs.buildPath(FLD_OVERLAY, "tlbdata.xml"))
tileImage.overlayText = overlayTLBData.getItemAttribute("Text.vbs", "leftText")

tileImage.overlayFontColor = formatColorName(overlayTLBData.getItemAttribute("Font Color.vbs", "leftText"))
tileImage.overlayBackgroundColor = formatColorName(overlayTLBData.getItemAttribute("Background Color.vbs", "leftText"))

set overlayTLBData = nothing

set fvar = get_CFileVar(FLD_OVERLAY, "Position")
tileImage.overlayPosition = fvar.value

set fvar = get_CFileVar(FLD_OVERLAY, "Show")
tileImage.overlayShow = fvar.value

set fvar = get_CFileVar(FLD_OVERLAY, "Font Size")
tileImage.overlayFontSize = fvar.value
'End Overlay

tileImage.tileSize = tileSizeVar.value

ret = tileImage.create

gws.sendkeys "^%q"
gws.sendkeys HK_REFRESH
