'**** INCLUDED FILE: classes\_debug.vbs ****
dbg = 0

sub we (name, value)
    if dbg = 1 then
        wscript.echo(name & ": " & value)
    end if
end sub
'**** END INCLUDED FILE: classes\_debug.vbs ****

'**** INCLUDED FILE: classes\_global.vbs ****
' Global objects
dim gws, gfs 
set gws = CreateObject("Wscript.Shell")
set gfs = CreateObject("Scripting.FileSystemObject")

' TLB
FLD_TLBHOME = gfs.buildPath(gws.ExpandEnvironmentStrings("%PROGRAMFILES%"), "TrueLaunchBar")
FLD_TLBSKINS = gfs.buildPath(FLD_TLBHOME, "skins")

FLD_APPDATA = gws.SpecialFolders("AppData")
FLD_TLBOPTIONS = gfs.buildPath(FLD_APPDATA, "Tordex\True Launch Bar")
F_TLBOPTIONS = gfs.buildPath(FLD_TLBOPTIONS, "options.xml")

' Folders
FLD_HOME = gfs.buildPath(FLD_TLBSKINS, "M8 Tile Editor") 
FLD_TOOLBAR = gfs.buildPath(FLD_HOME, "toolbar")
FLD_SCRIPTS = gfs.buildPath(FLD_HOME, "scripts")
FLD_ICON = gfs.buildPath(FLD_TOOLBAR, "Icon")
FLD_CAPTION = gfs.buildPath(FLD_TOOLBAR, "Caption")
FLD_OVERLAY = gfs.buildPath(FLD_TOOLBAR, "Overlay")

' Hotkeys
HK_REFRESH = "^{F5}"          ' CTRL+F5
HK_TEREFRESH = "^%r"


sub createScriptWrapper(pWrapper, pScriptName)

    set f = gfs.createTextFile(pWrapper, true)

    f.writeline("<job id=""" & pScriptName & """>")
    f.writeline("   <script language=""VBScript"" src=""" & gfs.buildPath(FLD_SCRIPTS, pScriptName) & """/>")
    f.writeline("</job>")

    f.close
    
end sub 'createScriptWrapper
  
  
function isValue(obj)

    dim tmp
    on error resume next
    tmp = " " & obj
    if err <> 0 Then
        isValue = false
    else
        isValue = True
    end If
    on error goto 0

end function


function nvl(pVar, pValueIfNull)

	nvl = pVar
	if isNull(nvl) then nvl = pValueIfNull

end function


function bp(pRoot, pPath)
	bp = gfs.buildPath(pRoot, pPath)
end function
'**** END INCLUDED FILE: classes\_global.vbs ****

'**** INCLUDED FILE: classes\_CFile.vbs ****


function new_CFile(pFile)

    set new_CFile = new CFile
    new_CFile.fullpath = pFile

end function 


class CFile

    public fullpath

    public function folder
        folder = gfs.getParentFolderName(fullPath)
    end function

    public function parentFolder
        parentFolder = gfs.getParentFolderName(folder)
    end function
    	
    public function foldername
        folderName = gfs.getBaseName(folder)
    end function    
  
    public function filename
        fileName = gfs.getFileName(fullPath)
    end function

    public function name
        name = gfs.getBaseName(fullPath)
    end function

    public function extension
        extension = gfs.getExtensionName(fullPath)
    end function

    
    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "filename: " & filename & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "extension: " & extension & vbcrlf & _
                    "foldername: " & foldername & vbcrlf & _
                    "fullpath: " & fullpath

    end function 'toString

    public sub show
    
        msgbox toString, vbInformation, "CFile" 
        
    end sub 'show
       

    public function rename(pNewName)
    
        set rename = new_CFile(gfs.buildPath(folder, pNewName))
        
    end function 'rename

    public function exists
    
        fileExists = gfs.fileExists(fullPath)
        folderExists = gfs.folderExists(fullPath)
        
        exists = fileExists OR folderExists
        
    end function    

    public function isFolder
    
        fileExists = gfs.fileExists(fullPath)
        folderExists = gfs.folderExists(fullPath)    

        ret = false
        if fileExists then
            ret = false
        elseif folderExists then
            ret = true
        elseif me.extension = "" then
            ret = true
        else
            ret = false
        end if    
        
    end function
    
    public function newInstance

        set nxt = me
        i = 0
        do until not nxt.exists
            i = i + 1
            if not me.isFolder then
                set nxt = new_CFile(gfs.buildPath(me.folder, me.name & i & "." & me.extension))
            else
                set nxt = new_CFile(gfs.buildPath(me.folder, me.name & i))
            end if
        loop

        set newInstance = nxt

    end function        
    
    public sub setHidden
    
        set f = gfs.getFile(me.fullPath)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if
    
    end sub


    function getProperty(pPropertyName)
            
        Set objShell = CreateObject("Shell.Application")
        Set objFolder = objShell.Namespace(me.folder)

        i = -1
        do
            i = i + 1
            prop = objFolder.GetDetailsOf(objFolder.Items, i)
        loop until prop = pPropertyName or i > 33

        getProperty = ""
        
        For Each strFileName in objFolder.Items
            if strFileName = me.filename then
               getProperty = objFolder.GetDetailsOf(strFileName, i) 
               exit for
            end if
        next        
       
'        if prop = pPropertyName then
'            getProperty = objFolder.GetDetailsOf(me.fullpath, i)
'        else
'            getProperty = ""
'        end if    

    end function


    
'    public function fileObject
'        set fileObject = new File(fullpath)
'    end function
    
end class 'CFile    
'**** END INCLUDED FILE: classes\_CFile.vbs ****

'**** INCLUDED FILE: classes\_CToolbar.vbs ****

'#USES classes\_CMenu.vbs
'#USES classes\_CItem.vbs
'**** INCLUDED FILE: classes\_CINIFile.vbs ****
class CINIFile

    public aFile
    private lastIndex
    
    sub load(pINIFile)

        set fs = createObject("Scripting.FileSystemObject")    
        set file = fs.openTextFile( pINIFile, 1, True )
        aFile = split(file.readAll(), vbCRLF)    
        file.close
        
    end sub


    sub save(pINIFile)

        set fs = createObject("Scripting.FileSystemObject")    
        set file = fs.openTextFile(pINIFile, 2, false)
        sFile = join(aFile, vbCRLF)
        file.write(sFile)
        file.close
        
    end sub

    
    function getKeyValue(pSection, pKey)
    
        index = findKey(pSection, pKey)
        
        splitLine = split(aFile(index), "=")
        getKeyValue = ""
        if lcase(trim(splitLine(0))) = lcase(trim(pKey)) then
            getKeyValue = splitLine(1)
        end if    

    end function 'getKeyValue


    function getKeys(pKey)
    
        set getKeys = createObject("Scripting.Dictionary")
        
        for each line in aFile
            trimmedLine = trim(line)
            if NOT trimmedLine = "" then
                splitLine = split(trimmedLine, "=")
                if lcase(trim(splitLine(0))) = lcase(trim(pKey)) then
                    if not getKeys.exists(splitLine(1)) then
                        getKeys.add splitLine(1), ""
                    end if    
                end if    
            end if
        next
        
    end function 'getKeys
    

    
    function findKey(pSection, pKey)

        ' returns the line number of the found key, 0 if the keys does not exist
        ' and -1 if the section does not exist.
        
        ret = 0
        sectionFound = false
        index = -1
        for each line in aFile
            
            index = index + 1    
            trimmedLine = trim(line)             
            
            if NOT sectionFound then
          
                if replace(lcase(trimmedLine), lcase(pSection), "") = "[]" then
                    sectionFound = true
                end if    

            else
                
                if left(trimmedLine, 1) = "[" then
                    exit for
                else
                    splitLine = split(trimmedLine, "=")
                    
                    if ubound(splitLine) > -1 then
                        if lcase(trim(splitLine(0))) = lcase(pKey) then
                            ret = index
                            exit for
                        end if    
                    end if
                end if
            end if

        next

        lastIndex = index

        if not sectionFound then
            ret = -1
        end if    
            
        findKey = ret

    end function

    sub setKeyValue(pSection, pKey, pValue)
    
        index = findKey(pSection, pKey)
        if index > 0 then 
            splitLine = split(aFile(index), "=")
            if lcase(trim(splitLine(0))) = lcase(trim(pKey)) then
                aFile(index) = splitLine(0) & "=" & pValue
            end if
        else
       
            if index = -1 then
                ubnd = ubound(aFile) + 2
                redim preserve aFile(ubnd)
                aFile(ubnd-1) = "[" & pSection & "]"
                aFile(ubnd) = pKey & "=" & pValue
                
            else 
                ubnd = ubound(aFile)
                redim preserve aFile(ubnd + 1)
                for i = ubnd to lastIndex + 1 step -1
                    aFile(i+1) = aFile(i) 
                next
                aFile(lastIndex+1) = pKey & "=" & pValue
            end if   
                
        end if            
    
    end sub 'setKeyValue

    
    public function findSections(pSection)
    
        set findSections = CreateObject("Scripting.Dictionary")
        
        for each line in aFile
            trimmedLine = trim(line)
            if left(trimmedLine, len(pSection) + 1) = "[" & pSection then
                findSections.add mid(trimmedLine, 2, len(trimmedLine) - 2), ""
            end if
        next        

    end function
    
    function getSection(pSection)
    
        set getSection = createObject("Scripting.Dictionary")
        
        start = false
        for each line in aFile
            trimmedLine = trim(line)
            if start then
                if left(trimmedLine, 1) = "[" then
                    exit for
                end if
                if not trimmedLine = "" then
                    splitLine = split(trimmedLine, "=")
                    getSection.add splitLine(0), splitLine(1)
                 end if   
            end if
            if trimmedLine = "[" & pSection & "]" then
                start = true
            end if
        next
        
    end function

    
    public function nextSectionInstance(pSection)
    
        set sections = findSections(pSection)
        nextInstance = 0
        for each section in sections
            instance = replace(section, pSection, "")
            if isNumeric(instance) then
                if instance > nextInstance then
                    nextInstance = instance + 1
                end if
            end if
        next

        nextSectionInstance = pSection & nextInstance

                        
    end function    
              
    
    
    private sub Class_Initialize
        lastIndex = 0
    end sub

    
end class 'CINIFile


'**** END INCLUDED FILE: classes\_CINIFile.vbs ****

'#USES classes\_CWorkSpace.vbs



function new_CToolbar(pPath)

    set this = new CToolbar
    this.folder = pPath
    this.name = gfs.getBaseName(this.folder)
    this.tlbdata = gfs.buildPath(this.folder, "tlbdata.xml")
    this.setup = gfs.buildPath(this.folder, "setup.ini")
    this.images = gfs.buildPath(this.folder, "~~images~~")
    this.btnImages = gfs.buildPath(this.images, "btnimages")
    this.icons = gfs.buildPath(this.images, "icons")
    this.overlays = gfs.buildPath(this.images, "overlays") 
    set new_CToolbar = this

end function 'new_CToolbar

class CToolbar

    public name
    public folder
    public tlbdata
    public setup
    public images
    public btnImages
    public icons
    public overlays

    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "tlbdata: " & tlbdata & vbcrlf & _
                    "setup: " & setup & vbcrlf & _
                    "images: " & images & vbcrlf & _
                    "btnImages: " & btnImages & vbcrlf & _
                    "icons: " & icons & vbcrlf & _
                    "overlays: " & overlays

    end function 'toString

    public sub show(pInstanceName)
    
        msgbox toString, vbInformation, pInstanceName & " (instance of CToolbar)" 
        
    end sub 'show

    public sub create
    
        gfs.createFolder(folder)
        gfs.createFolder(images)
        gfs.createFolder(btnimages)
        gfs.createFolder(icons)
        set otlbdata = new_CTLBData(tlbdata)
        otlbdata.save
        set tlboptions = load_CTLBData(F_TLBOPTIONS)
        set toolbarsNode = tlboptions.xmldoc.selectSingleNode("truelaunchbar/toolbars")

        set nums = createObject("Scripting.Dictionary")        
        for each toolbar in toolbarsNode.childNodes
            split1 = split(toolbar.getAttribute("name"), ". MetroTLB ")
            if ubound(split1) = 1 then
               if isNumeric(split1(0)) then
                    n = int(split1(0))
                    if not nums.exists(n) then
                        nums.add n, split1(1)
                    end if    
                end if
            end if
        next
        
        i = 1
        do until not nums.exists(i)
            i = i + 1
        loop
            
'        msgbox i
        set toolbarElement = tlboptions.xmlDoc.createElement("toolbar")
        toolbarElement.setAttribute "name", i & ". MetroTLB " & name            
        toolbarElement.setAttribute "path", folder    
        toolbarsNode.appendChild(toolbarElement)
        tlboptions.save
        gfs.copyFile gfs.buildPath(FLD_TOOLBARS, "setup.ini"), folder & "\"

    end sub
    
    public function getHotKey
    
            set ox = load_CTLBData(F_TLBOPTIONSXML)
            set tb=ox.xmlDoc.selectSingleNode("truelaunchbar/toolbars/toolbar[contains(@name, 'MetroTLB " & itemBaseName & "')]")
            msgbox tb.getAttribute("name")
    end function    
    
    
end class    
    
'**** END INCLUDED FILE: classes\_CToolbar.vbs ****

'**** INCLUDED FILE: classes\_CFileVar.vbs ****
function new_CFileVar(pFolder, pName, pValue)

    set new_CFileVar = new CFileVar
	new_CFileVar.folder = pFolder
    new_CFileVar.name = pName
	new_CFileVar.setValue pValue

end function 

function get_CFileVar(pFolder, pName)

    set get_CFileVar = new CFileVar
	get_CFileVar.folder = pFolder
    get_CFileVar.name = pName
	get_CFileVar.value = empty
	
	set varFile = get_CFileVar.getVarFile

	if not varFile is nothing then
		varFileName = varFile.name
		split1 = split(varFileName, "[")
		if ubound(split1) = 1 then
			split2 = split(split1(1), "]")
			get_CFileVar.value = split2(0)	
		end if
	end if	
	
end function 


class CFileVar

	public name
	
	public value
	
	public folder

	public function getVarFile
	
		set getVarFile = nothing
		set fld = gfs.getFolder(folder)

		for each f in fld.subFolders
			if NOT instr(f.name, name & " [") = 0 then
				set getVarFile = gfs.getFolder(f.path)
				exit for
			end if	
		next
		
		if getVarFile is nothing then
			for each f in fld.files
				if NOT instr(f.name, name & " [") = 0 then	
					set getVarFile = gfs.getFile(f.path)
					exit for
				end if	
			next
		end if	
		
	end function

	public sub hide
	
		set f = gfs.getFolder(fullpath)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if

	end sub
	
	public function fullPath
	
		fullPath = gfs.buildPath(folder, name & " [" & value & "]")
		
	end function

	public sub setValue(pValue)
		
		value = pValue
		set varFile = getVarFile

		if not varFile is nothing then
			ext = gfs.getExtensionName(varFile.path)
			if not ext = "" then
				if not gfs.fileExists(fullPath & "." & ext) then
				    done = false
					timer1 = 0
					do
						on error resume next
						varFile.name = gfs.getBaseName(fullPath) & "." & ext
						if err.number = 0 then
							done = true
							on error resume next
						else	
							wscript.sleep 100
							timer1 = timer1 + 100
						end if
					loop until done or timer1 > 2000		
				end if	
			else
				if not gfs.folderExists(fullPath) then
				    done = false
					timer2 = 0
					do
						on error resume next
						varFile.name = gfs.getBaseName(fullPath) & "." & ext
						if err.number = 0 then
							done = true
							on error resume next
						else	
							wscript.sleep 100
							timer2 = timer2 + 100
						end if
					loop until done or timer2 > 2000
				end if
			end if	
		end if	

	end sub
 
    
    
    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "value: " & value & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "fullpath: " & fullpath

    end function

    public sub show
    
        msgbox toString, vbInformation, "CFileVar" 
        
    end sub
	
end class 
'**** END INCLUDED FILE: classes\_CFileVar.vbs ****


set script = new_CFile(wscript.scriptFullName)
set toolbar = new_CToolbar(FLD_TOOLBAR)

set fvar = get_CFileVar(toolbar.folder, "Tile Size")

if fvar.value = "Smaller" then
	fvar.setValue "Larger"
else
	fvar.setValue "Smaller"
end if	

gws.sendkeys HK_TEREFRESH
