'**** INCLUDED FILE: classes\_global.vbs ****
' Global objects
dim gws, gfs 
set gws = CreateObject("Wscript.Shell")
set gfs = CreateObject("Scripting.FileSystemObject")

' TLB
FLD_TLBHOME = gfs.buildPath(gws.ExpandEnvironmentStrings("%PROGRAMFILES%"), "TrueLaunchBar")
FLD_TLBSKINS = gfs.buildPath(FLD_TLBHOME, "skins")

FLD_APPDATA = gws.SpecialFolders("AppData")
FLD_TLBOPTIONS = gfs.buildPath(FLD_APPDATA, "Tordex\True Launch Bar")
F_TLBOPTIONS = gfs.buildPath(FLD_TLBOPTIONS, "options.xml")

' Folders
FLD_HOME = gfs.buildPath(FLD_TLBSKINS, "M8 Tile Editor") 
FLD_TOOLBAR = gfs.buildPath(FLD_HOME, "toolbar")
FLD_SCRIPTS = gfs.buildPath(FLD_HOME, "scripts")
FLD_ICON = gfs.buildPath(FLD_TOOLBAR, "Icon")
FLD_CAPTION = gfs.buildPath(FLD_TOOLBAR, "Caption")
FLD_OVERLAY = gfs.buildPath(FLD_TOOLBAR, "Overlay")

' Hotkeys
HK_REFRESH = "^{F5}"          ' CTRL+F5
HK_TEREFRESH = "^%r"


sub createScriptWrapper(pWrapper, pScriptName)

    set f = gfs.createTextFile(pWrapper, true)

    f.writeline("<job id=""" & pScriptName & """>")
    f.writeline("   <script language=""VBScript"" src=""" & gfs.buildPath(FLD_SCRIPTS, pScriptName) & """/>")
    f.writeline("</job>")

    f.close
    
end sub 'createScriptWrapper
  
  
function isValue(obj)

    dim tmp
    on error resume next
    tmp = " " & obj
    if err <> 0 Then
        isValue = false
    else
        isValue = True
    end If
    on error goto 0

end function


function nvl(pVar, pValueIfNull)

	nvl = pVar
	if isNull(nvl) then nvl = pValueIfNull

end function


function bp(pRoot, pPath)
	bp = gfs.buildPath(pRoot, pPath)
end function
'**** END INCLUDED FILE: classes\_global.vbs ****

'**** INCLUDED FILE: classes\_CFile.vbs ****


function new_CFile(pFile)

    set new_CFile = new CFile
    new_CFile.fullpath = pFile

end function 


class CFile

    public fullpath

    public function folder
        folder = gfs.getParentFolderName(fullPath)
    end function

    public function parentFolder
        parentFolder = gfs.getParentFolderName(folder)
    end function
    	
    public function foldername
        folderName = gfs.getBaseName(folder)
    end function    
  
    public function filename
        fileName = gfs.getFileName(fullPath)
    end function

    public function name
        name = gfs.getBaseName(fullPath)
    end function

    public function extension
        extension = gfs.getExtensionName(fullPath)
    end function

    
    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "filename: " & filename & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "extension: " & extension & vbcrlf & _
                    "foldername: " & foldername & vbcrlf & _
                    "fullpath: " & fullpath

    end function 'toString

    public sub show
    
        msgbox toString, vbInformation, "CFile" 
        
    end sub 'show
       

    public function rename(pNewName)
    
        set rename = new_CFile(gfs.buildPath(folder, pNewName))
        
    end function 'rename

    public function exists
    
        fileExists = gfs.fileExists(fullPath)
        folderExists = gfs.folderExists(fullPath)
        
        exists = fileExists OR folderExists
        
    end function    

    public function isFolder
    
        fileExists = gfs.fileExists(fullPath)
        folderExists = gfs.folderExists(fullPath)    

        ret = false
        if fileExists then
            ret = false
        elseif folderExists then
            ret = true
        elseif me.extension = "" then
            ret = true
        else
            ret = false
        end if    
        
    end function
    
    public function newInstance

        set nxt = me
        i = 0
        do until not nxt.exists
            i = i + 1
            if not me.isFolder then
                set nxt = new_CFile(gfs.buildPath(me.folder, me.name & i & "." & me.extension))
            else
                set nxt = new_CFile(gfs.buildPath(me.folder, me.name & i))
            end if
        loop

        set newInstance = nxt

    end function        
    
    public sub setHidden
    
        set f = gfs.getFile(me.fullPath)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if
    
    end sub


    function getProperty(pPropertyName)
            
        Set objShell = CreateObject("Shell.Application")
        Set objFolder = objShell.Namespace(me.folder)

        i = -1
        do
            i = i + 1
            prop = objFolder.GetDetailsOf(objFolder.Items, i)
        loop until prop = pPropertyName or i > 33

        getProperty = ""
        
        For Each strFileName in objFolder.Items
            if strFileName = me.filename then
               getProperty = objFolder.GetDetailsOf(strFileName, i) 
               exit for
            end if
        next        
       
'        if prop = pPropertyName then
'            getProperty = objFolder.GetDetailsOf(me.fullpath, i)
'        else
'            getProperty = ""
'        end if    

    end function


    
'    public function fileObject
'        set fileObject = new File(fullpath)
'    end function
    
end class 'CFile    
'**** END INCLUDED FILE: classes\_CFile.vbs ****

'**** INCLUDED FILE: classes\_CFileVar.vbs ****
function new_CFileVar(pFolder, pName, pValue)

    set new_CFileVar = new CFileVar
	new_CFileVar.folder = pFolder
    new_CFileVar.name = pName
	new_CFileVar.setValue pValue

end function 

function get_CFileVar(pFolder, pName)

    set get_CFileVar = new CFileVar
	get_CFileVar.folder = pFolder
    get_CFileVar.name = pName
	get_CFileVar.value = empty
	
	set varFile = get_CFileVar.getVarFile

	if not varFile is nothing then
		varFileName = varFile.name
		split1 = split(varFileName, "[")
		if ubound(split1) = 1 then
			split2 = split(split1(1), "]")
			get_CFileVar.value = split2(0)	
		end if
	end if	
	
end function 


class CFileVar

	public name
	
	public value
	
	public folder

	public function getVarFile
	
		set getVarFile = nothing
		set fld = gfs.getFolder(folder)

		for each f in fld.subFolders
			if NOT instr(f.name, name & " [") = 0 then
				set getVarFile = gfs.getFolder(f.path)
				exit for
			end if	
		next
		
		if getVarFile is nothing then
			for each f in fld.files
				if NOT instr(f.name, name & " [") = 0 then	
					set getVarFile = gfs.getFile(f.path)
					exit for
				end if	
			next
		end if	
		
	end function

	public sub hide
	
		set f = gfs.getFolder(fullpath)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if

	end sub
	
	public function fullPath
	
		fullPath = gfs.buildPath(folder, name & " [" & value & "]")
		
	end function

	public sub setValue(pValue)
		
		value = pValue
		set varFile = getVarFile

		if not varFile is nothing then
			ext = gfs.getExtensionName(varFile.path)
			if not ext = "" then
				if not gfs.fileExists(fullPath & "." & ext) then
				    done = false
					timer1 = 0
					do
						on error resume next
						varFile.name = gfs.getBaseName(fullPath) & "." & ext
						if err.number = 0 then
							done = true
							on error resume next
						else	
							wscript.sleep 100
							timer1 = timer1 + 100
						end if
					loop until done or timer1 > 2000		
				end if	
			else
				if not gfs.folderExists(fullPath) then
				    done = false
					timer2 = 0
					do
						on error resume next
						varFile.name = gfs.getBaseName(fullPath) & "." & ext
						if err.number = 0 then
							done = true
							on error resume next
						else	
							wscript.sleep 100
							timer2 = timer2 + 100
						end if
					loop until done or timer2 > 2000
				end if
			end if	
		end if	

	end sub
 
    
    
    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "value: " & value & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "fullpath: " & fullpath

    end function

    public sub show
    
        msgbox toString, vbInformation, "CFileVar" 
        
    end sub
	
end class 
'**** END INCLUDED FILE: classes\_CFileVar.vbs ****

'**** INCLUDED FILE: classes\_CToolbar.vbs ****

'#USES classes\_CMenu.vbs
'#USES classes\_CItem.vbs
'**** INCLUDED FILE: classes\_CINIFile.vbs ****
class CINIFile

    public aFile
    private lastIndex
    
    sub load(pINIFile)

        set fs = createObject("Scripting.FileSystemObject")    
        set file = fs.openTextFile( pINIFile, 1, True )
        aFile = split(file.readAll(), vbCRLF)    
        file.close
        
    end sub


    sub save(pINIFile)

        set fs = createObject("Scripting.FileSystemObject")    
        set file = fs.openTextFile(pINIFile, 2, false)
        sFile = join(aFile, vbCRLF)
        file.write(sFile)
        file.close
        
    end sub

    
    function getKeyValue(pSection, pKey)
    
        index = findKey(pSection, pKey)
        
        splitLine = split(aFile(index), "=")
        getKeyValue = ""
        if lcase(trim(splitLine(0))) = lcase(trim(pKey)) then
            getKeyValue = splitLine(1)
        end if    

    end function 'getKeyValue


    function getKeys(pKey)
    
        set getKeys = createObject("Scripting.Dictionary")
        
        for each line in aFile
            trimmedLine = trim(line)
            if NOT trimmedLine = "" then
                splitLine = split(trimmedLine, "=")
                if lcase(trim(splitLine(0))) = lcase(trim(pKey)) then
                    if not getKeys.exists(splitLine(1)) then
                        getKeys.add splitLine(1), ""
                    end if    
                end if    
            end if
        next
        
    end function 'getKeys
    

    
    function findKey(pSection, pKey)

        ' returns the line number of the found key, 0 if the keys does not exist
        ' and -1 if the section does not exist.
        
        ret = 0
        sectionFound = false
        index = -1
        for each line in aFile
            
            index = index + 1    
            trimmedLine = trim(line)             
            
            if NOT sectionFound then
          
                if replace(lcase(trimmedLine), lcase(pSection), "") = "[]" then
                    sectionFound = true
                end if    

            else
                
                if left(trimmedLine, 1) = "[" then
                    exit for
                else
                    splitLine = split(trimmedLine, "=")
                    
                    if ubound(splitLine) > -1 then
                        if lcase(trim(splitLine(0))) = lcase(pKey) then
                            ret = index
                            exit for
                        end if    
                    end if
                end if
            end if

        next

        lastIndex = index

        if not sectionFound then
            ret = -1
        end if    
            
        findKey = ret

    end function

    sub setKeyValue(pSection, pKey, pValue)
    
        index = findKey(pSection, pKey)
        if index > 0 then 
            splitLine = split(aFile(index), "=")
            if lcase(trim(splitLine(0))) = lcase(trim(pKey)) then
                aFile(index) = splitLine(0) & "=" & pValue
            end if
        else
       
            if index = -1 then
                ubnd = ubound(aFile) + 2
                redim preserve aFile(ubnd)
                aFile(ubnd-1) = "[" & pSection & "]"
                aFile(ubnd) = pKey & "=" & pValue
                
            else 
                ubnd = ubound(aFile)
                redim preserve aFile(ubnd + 1)
                for i = ubnd to lastIndex + 1 step -1
                    aFile(i+1) = aFile(i) 
                next
                aFile(lastIndex+1) = pKey & "=" & pValue
            end if   
                
        end if            
    
    end sub 'setKeyValue

    
    public function findSections(pSection)
    
        set findSections = CreateObject("Scripting.Dictionary")
        
        for each line in aFile
            trimmedLine = trim(line)
            if left(trimmedLine, len(pSection) + 1) = "[" & pSection then
                findSections.add mid(trimmedLine, 2, len(trimmedLine) - 2), ""
            end if
        next        

    end function
    
    function getSection(pSection)
    
        set getSection = createObject("Scripting.Dictionary")
        
        start = false
        for each line in aFile
            trimmedLine = trim(line)
            if start then
                if left(trimmedLine, 1) = "[" then
                    exit for
                end if
                if not trimmedLine = "" then
                    splitLine = split(trimmedLine, "=")
                    getSection.add splitLine(0), splitLine(1)
                 end if   
            end if
            if trimmedLine = "[" & pSection & "]" then
                start = true
            end if
        next
        
    end function

    
    public function nextSectionInstance(pSection)
    
        set sections = findSections(pSection)
        nextInstance = 0
        for each section in sections
            instance = replace(section, pSection, "")
            if isNumeric(instance) then
                if instance > nextInstance then
                    nextInstance = instance + 1
                end if
            end if
        next

        nextSectionInstance = pSection & nextInstance

                        
    end function    
              
    
    
    private sub Class_Initialize
        lastIndex = 0
    end sub

    
end class 'CINIFile


'**** END INCLUDED FILE: classes\_CINIFile.vbs ****

'#USES classes\_CWorkSpace.vbs



function new_CToolbar(pPath)

    set this = new CToolbar
    this.folder = pPath
    this.name = gfs.getBaseName(this.folder)
    this.tlbdata = gfs.buildPath(this.folder, "tlbdata.xml")
    this.setup = gfs.buildPath(this.folder, "setup.ini")
    this.images = gfs.buildPath(this.folder, "~~images~~")
    this.btnImages = gfs.buildPath(this.images, "btnimages")
    this.icons = gfs.buildPath(this.images, "icons")
    this.overlays = gfs.buildPath(this.images, "overlays") 
    set new_CToolbar = this

end function 'new_CToolbar

class CToolbar

    public name
    public folder
    public tlbdata
    public setup
    public images
    public btnImages
    public icons
    public overlays

    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "tlbdata: " & tlbdata & vbcrlf & _
                    "setup: " & setup & vbcrlf & _
                    "images: " & images & vbcrlf & _
                    "btnImages: " & btnImages & vbcrlf & _
                    "icons: " & icons & vbcrlf & _
                    "overlays: " & overlays

    end function 'toString

    public sub show(pInstanceName)
    
        msgbox toString, vbInformation, pInstanceName & " (instance of CToolbar)" 
        
    end sub 'show

    public sub create
    
        gfs.createFolder(folder)
        gfs.createFolder(images)
        gfs.createFolder(btnimages)
        gfs.createFolder(icons)
        set otlbdata = new_CTLBData(tlbdata)
        otlbdata.save
        set tlboptions = load_CTLBData(F_TLBOPTIONS)
        set toolbarsNode = tlboptions.xmldoc.selectSingleNode("truelaunchbar/toolbars")

        set nums = createObject("Scripting.Dictionary")        
        for each toolbar in toolbarsNode.childNodes
            split1 = split(toolbar.getAttribute("name"), ". MetroTLB ")
            if ubound(split1) = 1 then
               if isNumeric(split1(0)) then
                    n = int(split1(0))
                    if not nums.exists(n) then
                        nums.add n, split1(1)
                    end if    
                end if
            end if
        next
        
        i = 1
        do until not nums.exists(i)
            i = i + 1
        loop
            
'        msgbox i
        set toolbarElement = tlboptions.xmlDoc.createElement("toolbar")
        toolbarElement.setAttribute "name", i & ". MetroTLB " & name            
        toolbarElement.setAttribute "path", folder    
        toolbarsNode.appendChild(toolbarElement)
        tlboptions.save
        gfs.copyFile gfs.buildPath(FLD_TOOLBARS, "setup.ini"), folder & "\"

    end sub
    
    public function getHotKey
    
            set ox = load_CTLBData(F_TLBOPTIONSXML)
            set tb=ox.xmlDoc.selectSingleNode("truelaunchbar/toolbars/toolbar[contains(@name, 'MetroTLB " & itemBaseName & "')]")
            msgbox tb.getAttribute("name")
    end function    
    
    
end class    
    
'**** END INCLUDED FILE: classes\_CToolbar.vbs ****

'**** INCLUDED FILE: classes\_CTLBFolder.vbs ****

'**** INCLUDED FILE: classes\_CTLBData.vbs ****
'**** INCLUDED FILE: classes\_xfso.vbs ****

set gxfs = new xfso

class xfso

    public function isFolder(pPath)
    
        fileExists = gfs.fileExists(pPath)
        folderExists = gfs.folderExists(pPath)    
        ret = false
        if gfs.fileExists(pPath) then
            ret = false
        elseif gfs.folderExists(pPath) then
            ret = true
        elseif gfs.getExtensionName(pPath) = "" then
            ret = true
        else
            ret = false
        end if    
        isFolder = ret
        
    end function
    

    function newFileInstance(pPath)

        nxt = pPath
        i = 0
        do until not gfs.fileExists(nxt)
            i = i + 1
            nxt = gfs.buildPath(gfs.getParentFolderName(pPath), gfs.getBaseName(pPath) & i & "." & gfs.getExtensionName(pPath))
        loop
        newFileInstance = nxt
    
    end function
    
    function newFolderInstance(pPath)

        nxt = pPath
        i = 0
        do until not gfs.folderExists(nxt)
            i = i + 1
            nxt = gfs.buildPath(gfs.getParentFolderName(pPath), gfs.getBaseName(pPath) & i)
        loop
        newFolderInstance = nxt

    end function

    function newInstance(pPath)

        if isFolder(pPath) then
            newInstance = newFolderInstance(pPath)    
        else
            newInstance = newFileInstance(pPath)
        end if

    end function

    function getParentFolderByName(pPath, pParentFolderName)

        dim fs
        set fs = createObject("Scripting.FileSystemObject")
        
        folderPath = pPath   
        do until fs.getBaseName(folderPath) = pParentFolderName or folderPath = "" 
            folderPath = fs.getParentFolderName(folderPath)   
        loop 
        
        if folderPath = pPath then folderPath = ""
        getParentFolderByName = folderPath
       
    end function 'getParentFolderByName   
  
  
    function getRandomFile(pFolder)
        
        dim f, fs
        set fs = CreateObject("Scripting.FileSystemObject")         
        set f = fs.getFolder(pFolder)
        
        Randomize
        i = CInt((Rnd() * f.Files.Count) + 1)
        j = 1 
        
        For Each fi In f.Files
           If j >= i Then 
              we "fi", fi
              Exit For
           End If
           j = j + 1
        Next

        getRandomFile = fi.path
        
    end function 'getRandomFile
  
     public sub TextFile_replaceString(pTextFile, pFind, pReplace)

        Set f = gfs.openTextFile(pTextFile, 1)

        strText = f.readAll
        f.close
        strNewText = replace(strText, pFind, pReplace)

        set f = gfs.openTextFile(pTextFile, 2)
        f.writeLine strNewText
        f.close
    
    end sub 'TextFile_replaceString

'    public function newFileInstance(pPath)
'
'        if not gfs.fileExists(pPath) then
'            f = pPath
'        else    
'            basePath = gfs.buildPath(gfs.getParentFolderName(pPath), gfs.getBaseName(pPath))
'            ext = gfs.getExtensionName(pPath)
'            i = 0
'            do
'                i = i + 1
'                f = basePath & i & "." & ext
'            loop while gfs.fileExists(f)
'        end if
'        newFileInstance = f
'
'    end function 'newFileInstance
    
    public sub wmiRename(pFilePath, pNewPath)

        fname = replace(pFilePath, "\", "\\")
        strComputer = "."
        Set objWMIService = GetObject _
            ("winmgmts:" & "!\\" & strComputer & "\root\cimv2")
        Set colFiles = objWMIService.ExecQuery _
            ("Select * from CIM_DataFile where Name = " _
                & "'" & fname & "'")
        For Each objFile in colFiles
            objfile.rename(pNewPath)
        Next    
    
    end sub
    
    public sub hideFile(pFile)
    
        set f = gfs.getFile(pFile)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if
    
    end sub
        
    public sub hideFolder(pFile)
    
        set f = gfs.getFolder(pFile)
        if f.Attributes = f.Attributes AND 2 then
            f.Attributes = f.Attributes XOR 2 
        end if
    
    end sub

    function findFiles(pFolder)
    
        set dicFiles = createObject("Scripting.Dictionary")
        objStartFolder = pFolder

        Set objFolder = gfs.GetFolder(objStartFolder)
        Set colFiles = objFolder.Files
        For Each objFile in colFiles
            dicFiles.add objFile.path, ""
        Next

        ShowSubfolders gfs.GetFolder(objStartFolder)

        for each f in dicFiles
            m = m & f & vbcrlf
        next
        Set filetxt = gfs.CreateTextFile("c:\somefile3.txt", True)
        path = gfs.GetAbsolutePathName("c:\somefile3.txt")
        getname = gfs.GetFileName(path)
        filetxt.Write(m)
        filetxt.Close
        
        set findFiles = dicFiles
        
    end function
        
    Sub ShowSubFolders(Folder)
        For Each Subfolder in Folder.SubFolders
            Set objFolder = gfs.GetFolder(Subfolder.Path)
            Set colFiles = objFolder.Files
            For Each objFile in colFiles
                dicFiles.add objFile.path, ""
            Next
            ShowSubFolders Subfolder
        Next
    End Sub
    
end class 'xfso
'**** END INCLUDED FILE: classes\_xfso.vbs ****



'**** INCLUDED FILE: classes\_CFolder.vbs ****


function new_CFolder(pFile)

    set new_CFolder = new CFolder
    new_CFolder.path = pFile

end function 'create


class CFolder

    public path

    public function name
        name = gfs.getBaseName(path)
    end function
    
    public sub write

        wscript.echo(toString)
        
    end sub 'write
    
    public function toString

        toString =  "name: " & name & vbcrlf & _
                    "path: " & path

    end function 'toString

    
    public function exists
    
        exists = gfs.folderExists(fullPath)
        
    end function    

    
    public sub create
    
        gfs.createFolder(path)
    
    end sub
 
    
    public function findFiles

        set objFSO = createObject("Scripting.FileSystemObject")
        set dicFiles = createObject("Scripting.Dictionary")
       
        set objFolder = objFSO.getFolder(path)
        set colFiles = objFolder.Files
        for each objFile in colFiles
            dicFiles.add objFile.path, ""
            msgbox "objFile:" & objFile.path
        next

        set colFolders = objFolder.subFolders
        for each objSubFolder in colFolders
        msgbox objSubFolder.path
            set subFolder = new_CFolder(objSubFolder.path)
            set dicSubFolderFiles = subFolder.findFiles
            for each subFolderFile in dicSubFolderFiles
                msgbox "XxXX" & subFolderFile.path
                dicFiles.add subFolderFile.path , ""
            next
            set subFolder = nothing
        next
    
        set findFiles = dicFiles
        
    end function 'findFiles



    
    
end class 'CFolder    
'**** END INCLUDED FILE: classes\_CFolder.vbs ****



public function new_CTLBData(ptlbdata)

        set new_CTLBData = new CTLBData  

        new_CTLBData.xmlDoc.loadXML("<?xml version=""1.0"" encoding=""utf-8""?>" & vbCRLF & _
            "<tlbdata>" & vbCRLF & _
            "    <folder name="""">" & vbCRLF & _
            "        <layout>" & vbCRLF & _
            "        </layout>" & vbCRLF & _
            "        <options skin="""" fontNameMI="""" fontSizeCAP=""0"" fontNameCAP="""" fontSizeTIT=""0"" fontNameTIT="""" disableGlass=""0"" disableTips=""0"" overlayFileName="""" overlayFlags=""34"" overlayTransparency=""255"" filterShowMask="""" filterHideMask=""""/>" & vbCRLF & _
            "    </folder>" & vbCRLF & _
            "</tlbdata>")        

        set new_CTLBData.options=new_CTLBData.xmlDoc.selectSingleNode("tlbdata/folder/options")     
      
        new_CTLBData.xmlDocPath = ptlbdata
            
end function


public function load_CTLBData(ptlbdata) 

    set load_CTLBData = new CTLBData
    load_CTLBData.load(ptlbdata)         
    load_CTLBData.xmlDocPath = ptlbdata
     
end function  
    

    

class CTLBData

    public function newItem(pName)
    
        set element = xmlDoc.createElement("item")
        element.setAttribute "name", pName    

        set newItem = element    

    end function
    
'   ** Public Methods

    public sub save
		on error resume next
        xmlDoc.save(xmlDocPath)
		on error goto 0
    end sub

    public sub saveAs(pFile)
		on error resume next
        xmlDoc.save(pFile)
		on error goto 0
    end sub
    
  
    function findItemByName(pItemName)
        set findItemByName=xmlDoc.selectSingleNode("//layout/item[@name='" & pItemName & "']")        
    end function

    public function getItemAttribute(pItemName, pAttribute)

        set itemNode=findItemByName(pItemName)
		if not itemNode is nothing then
			getItemAttribute = itemNode.getAttribute(pAttribute)
		end if
    end function

    public function getItemImagePath(pItemName)
        
        getItemImagePath = getItemAttribute(pItemName, "ImagePath")
    
    end function

    
    public sub setOption(pOptionName, pValue)
        
        set optionsNode=xmlDoc.selectSingleNode("tlbdata/folder/options")      
        optionsNode.setAttribute pOptionName, pValue
    
    end sub

    public function getOption(pOptionName)
        
        set optionsNode=xmlDoc.selectSingleNode("tlbdata/folder/options")      
        getOption = optionsNode.getAttribute(pOptionName)
        
    end function
   
    public function getOptions
        
        set getOptions=xmlDoc.selectSingleNode("tlbdata/folder/options")      
        
    end function
     
   
    public function toggleOption(pOptionName)
        
        curval = getOption(pOptionName)
        if curval = "1" then
            nxtval = "0"
        else
            nxtval = "1"
        end if
        setOption pOptionName, nxtval

    end function
      
    
    
    public sub setItemAttribute(pItemName, pAttribute, pValue)
        
        set itemNode=findItemByName(pItemName)
		if not itemNode is nothing then		
			itemNode.setAttribute pAttribute, pValue
		end if
		
    end sub

    public sub setItemImagePath(pItemName, pValue)

        setItemAttribute pItemName, "ImagePath", pValue

    end sub
    
    public sub setCaption(pItemName, pValue)

        set itemNode=findItemByName(pItemName)  
        itemNode.setAttribute "showCaption", "2"    
        set captionNode = xmlDoc.createElement("caption")
        set captionText = xmlDoc.createTextNode(pValue)
        captionNode.appendChild(captionText)
        itemNode.appendChild(captionNode)
       
    end sub
    
    public sub setIconLocation(pItemName, pValue)

        set itemNode=findItemByName(pItemName)  
        set captionNode = xmlDoc.createElement("IconLocation")
        set captionText = xmlDoc.createTextNode(pValue)
        captionNode.appendChild(captionText)
        itemNode.appendChild(captionNode)
       
    end sub
    
    public function getChildText(pItemName, pElementName)
        
        getChildText = ""
        dim itemNode
        set itemNode=findItemByName(pItemName)
		if not itemNode is nothing then
			for each node in itemNode.childNodes
				if node.nodeName = pElementName then
					getChildText = node.text
				end if
			next           
        end if
		
    end function
        
    public sub removeCaption(pItemName)

        set itemNode=findItemByName(pItemName)  
        set childNodes = itemNode.childNodes
        itemNode.setAttribute "showCaption", "0"
         
        for each childNode in childNodes 
            if childNode.nodeName = "caption" then
                itemNode.removeChild(childNode)
            end if     
        next
   
    end sub

    public sub removeDescription(pItemName)

        set itemNode=findItemByName(pItemName)  
        set childNodes = itemNode.childNodes
        itemNode.setAttribute "showDescription", "0"
         
        for each childNode in childNodes 
            if childNode.nodeName = "description" then
                itemNode.removeChild(childNode)
            end if     
        next
   
    end sub

    public sub removeChild(pItemName, pChildName)

        set itemNode=findItemByName(pItemName)  
        set childNodes = itemNode.childNodes
         
        for each childNode in childNodes 
            if childNode.nodeName = pChildName then
                itemNode.removeChild(childNode)
            end if     
        next
   
    end sub
        
	
    public sub hideItem(pItemName)

        setItemAttribute pItemName, "hidden", "1"
        
    end sub

    public sub showItem(pItemName)

        setItemAttribute pItemName, "hidden", "0"
     
    end sub

    public sub load(ptlbdata) 

        dim	counter
		counter = 0
		do while not xmlDoc.Load(ptlbdata) and counter < 1000
			wscript.sleep 50
			counter = counter + 50
		loop	
        xmlDocPath = ptlbdata
         
    end sub  
    
'   ** Public Properties
    
    public xmlDoc
    public xmlDocPath
    public options
    
'   ** Private Methods

    private sub Class_Initialize()
    
        set xmlDoc = createObject("Microsoft.XMLDOM")
        xmlDoc.Async = false
        xmlDoc.setProperty "SelectionLanguage", "XPath"
        
    end sub


    public function createItem(pItemName)

        set lItem = xmlDoc.createElement("item")
        lItem.setAttribute "name", pItemName
        set layoutNode = xmldoc.selectSingleNode("tlbdata/folder/layout")
        set createItem = layoutNode.appendChild(lItem)        

    end function
    
    public function appendItem(pXMLElement)

        set layoutNode = xmldoc.selectSingleNode("tlbdata/folder/layout")
        set appendItem = layoutNode.appendChild(pXMLElement)        

    end function
        
    
    
    public function createItemElement(pItemName)

        set createItemElement = xmlDoc.createElement("item")
        createItemElement.setAttribute "name", pItemName
'        set layoutNode = xmldoc.selectSingleNode("tlbdata/folder/layout")
'        set createItem = layoutNode.appendChild(newItem)        

    end function
        
    
    public function createItem2(pItemName, pImagePath)

        set newItem = xmlDoc.createElement("item")
        newItem.setAttribute "name", pItemName
        newItem.setAttribute "ImagePath", pImagePath
        set layoutNode = xmldoc.selectSingleNode("tlbdata/folder/layout")
        layoutNode.appendChild(newItem)        
        set createItem2 = newItem
        
        
    end function
    
    public sub createCaption(pNode, pCaptionText)
        
        dim newItem
        set newItem = xmlDoc.createElement("caption")
        newItem.text = pCaptionText
        pNode.appendChild(newItem)
        
    end sub

    public sub appendChildTextNode(pNode, pTextNodeName, pText)

        dim newItem
        set newItem = xmlDoc.createElement(pTextNodeName)
        newItem.text = pText
        pNode.appendChild(newItem)
       
    end sub

    
    public function createItemInstance(pItemName, pImagePath)

        itemBaseName = gfs.getBaseName(pItemName)
        itemExtension = gfs.getExtensionName(pItemName)
        set itemNodes = xmlDoc.selectNodes("//layout/item[contains(@name, '" & itemBaseName & "')]")

        usedItems = ""
        for each node in itemNodes
            usedItems = usedItems & "," & node.getAttribute("name")
        next
        
        i = 1
      
        do
            if itemExtension = "" then
                itemName = itemBaseName & i
            else
                itemName = itemBaseName & i & "." & itemExtension
            end if
            i = i + 1
        loop while instr(usedItems, itemName)

        set createItemInstance = createItem3(itemName, pImagePath, false)
        save

    end function 'createItemInstance
         
    function getIconLocation(pItemName)
        
		getIconLocation = ""   
        getIconLocation = getChildText(pItemName, "IconLocation")
    
    end function

end class 'CTLBDATA
'**** END INCLUDED FILE: classes\_CTLBData.vbs ****

'**** INCLUDED FILE: classes\_CFinder.vbs ****




class CFinder

    private found    

	private sub Class_Initialize()  
        set found = nothing
    end sub  
   
    public function findFilesByFilename(pStartFolder, pFileName, pRecurse) 

		if found is nothing then
			set found = createObject("Scripting.Dictionary")
		end if
		
        set objFolder = gfs.getFolder(pStartFolder)
        set colFiles = objFolder.Files
        for each objFile in colFiles
			if objFile.name = pFilename then
				found.add objFile.path, ""
			end if	
        next

		if pRecurse then
			set colFolders = objFolder.subFolders
			for each fld in colFolders
				set dummy = findFilesByFilename(fld.path, pFileName, true)
			next
		end if

		set findFilesByFilename = found
		
    end function

    public function findShortcuts(pStartFolder, pRecurse) 

		if found is nothing then
			set found = createObject("Scripting.Dictionary")
		end if
		
        set objFolder = gfs.getFolder(pStartFolder)
        set colFiles = objFolder.Files
        for each objFile in colFiles
			if gfs.getExtensionName(objFile.name) = "lnk" then
				found.add objFile.path, ""
			end if	
        next

		if pRecurse then
			set colFolders = objFolder.subFolders
			for each fld in colFolders
				set dummy = findShortcuts(fld.path, true)
			next
		end if

		set findShortcuts = found
		
    end function


	
end class    
    
'**** END INCLUDED FILE: classes\_CFinder.vbs ****


function new_CTLBFolder(pPath)

    set this = new CTLBFolder
    this.path = pPath
    set new_CTLBFolder = this
    
end function 'new_CTLBFolder

class CTLBFolder

    public path    
    
    public function name 
        name = gfs.getBaseName(path)
    end function

    public function folder 
        folder = gfs.getParentFolderName(path)
    end function
    
    public function tlbdata
        tlbdata = gfs.buildPath(path, "tlbdata.xml")
    end function    

    public function setup
        setup = gfs.buildPath(path, "setup.ini")
    end function    

	function isToolbar
		isToolbar =  gfs.fileExists(tlbdata) and gfs.fileExists(setup) and not gfs.fileExists(gfs.buildPath(path, "namespace.fld"))
	end function
    
	function findToolbar
	
		set tmpTLBFolder = me
		do while not tmpTLBFolder.isToolbar
			set tmpTLBFolder = new_CTLBFolder(tmpTLBFolder.folder)
		loop
		set findToolbar = tmpTLBFolder
		
	end function

	function isVirtual
		isVirtual =  gfs.fileExists(gfs.buildPath(folder, "namespace.fld"))
	end function
    
	
	function findVirtualFolders
		
		set vfdict = createObject("Scripting.Dictionary")
		
		set optionsxml = load_CTLBData(F_TLBOPTIONS)
		set toolbars = optionsxml.xmlDoc.selectNodes("//truelaunchbar/toolbars/toolbar")
		for each node in toolbars
			path = node.getAttribute("path")
			if gfs.folderExists(path) then
				set finder = new CFinder
				set foundFiles = finder.findFilesByFilename(path, "namespace.fld", true)
				for each ff in foundFiles.keys
					vfdict.add gfs.getParentFolderName(ff), ""
				next	
			end if
		next
		
		for each node in toolbars
			path = node.getAttribute("path")
			if gfs.folderExists(path) then
				set tbFolder = new_CToolbar(path)
				set setupINI = new CINIFile
				setupINI.load(tbFolder.setup)
				set layouts = setupINI.findSections("layout")
				for each layout in layouts
					layoutPath = setupINI.getKeyValue(layout, "folder")
					if gfs.folderExists(layoutPath) then
						set finder = new CFinder
						set foundFiles = finder.findFilesByFilename(layoutPath, "namespace.fld", true)
						for each ff in foundFiles.keys
							vfdict.add gfs.getParentFolderName(ff), ""
						next	
					end if		
				next
			end if		
		next
		
		set findVirtualFolders = vfdict
		
	end function
	
    public sub create
        gfs.createFolder(path)
    end sub 'create

    public function toString

        toString =  "path: " & path & vbcrlf & _
                    "name: " & name & vbcrlf & _
                    "folder: " & folder & vbcrlf & _
                    "tlbdata: " & tlbdata & vbcrlf & _
                    "setup: " & setup

    end function 'toString

    public sub show
    
        msgbox toString, vbInformation, "CTLBFolder" 
        
    end sub 'show
   
end class    
'**** END INCLUDED FILE: classes\_CTLBFolder.vbs ****




if wscript.arguments.count = 1 then
	value = wscript.arguments(0)
else
	wscript.quit
end if 

set script = new_CFile(wscript.scriptFullName)
set toolbar = new_CToolbar(FLD_TOOLBAR)

set presetsXML = createObject("Microsoft.XMLDOM")
presetsXML.Async = false
presetsXML.setProperty "SelectionLanguage", "XPath"
presetsXML.load(gfs.buildPath(FLD_SCRIPTS, "presets.xml"))


function mergeNodes(xmldoc, xpath1, xpath2)

	set node1 = xmldoc.selectSingleNode(xpath1)
	set node2 = xmldoc.selectSingleNode(xpath2)
	if node1 is nothing then
		set node1 = node2
	else
		for each attribute in node2.attributes
			if isNull(node1.getAttribute(attribute.name)) then
				node1.setAttribute attribute.name, attribute.value
			end if	
		next	
	end if
	set mergeNodes = node1

end function

function nvl(pVar, pValueIfNull)

	nvl = pVar
	if isNull(nvl) then nvl = pValueIfNull

end function


xpathPresetPrefix = "presets/preset[@name='" & value & "']/"
xpathDefaultPresetPrefix = "presets/preset[@name='Default']/"

set fvar = new_CFileVar(toolbar.folder, "Preset", value)

'Icon
set iconNode = mergeNodes(presetsXML, xpathPresetPrefix & "icon", xpathDefaultPresetPrefix & "icon")

set fvar = new_CFileVar(FLD_ICON, "Position", nvl(iconNode.getAttribute("position"), ""))
set fvar = new_CFileVar(FLD_ICON, "Size", nvl(iconNode.getAttribute("size"), ""))
set fvar = new_CFileVar(FLD_ICON, "Opacity", nvl(iconNode.getAttribute("opacity"), ""))
'End Icon

'Caption
set captionNode = mergeNodes(presetsXML, xpathPresetPrefix & "caption", xpathDefaultPresetPrefix & "caption")
set captionMenu = new_CTLBFolder(gfs.buildPath(toolbar.folder, "Caption"))
set captionMenuTLBData = load_CTLBData(captionMenu.tlbdata)

set fvar = new_CFileVar(FLD_CAPTION, "Show", nvl(captionNode.getAttribute("show"), ""))
set fvar = new_CFileVar(FLD_CAPTION, "Position", nvl(captionNode.getAttribute("position"), ""))
set fvar = new_CFileVar(FLD_CAPTION, "Font Size", nvl(captionNode.getAttribute("fontSize"), ""))

captionMenuTLBData.setItemAttribute "Font Color.vbs", "leftText", nvl(captionNode.getAttribute("fontColor"), "")
captionMenuTLBData.save
'End Caption

' Overlay
set overlayNode = mergeNodes(presetsXML, xpathPresetPrefix & "overlay", xpathDefaultPresetPrefix & "overlay")
set overlayMenu = new_CTLBFolder(gfs.buildPath(toolbar.folder, "overlay"))
set overlayMenuTLBData = load_CTLBData(overlayMenu.tlbdata)

set fvar = new_CFileVar(FLD_OVERLAY, "Show", nvl(overlayNode.getAttribute("show"), ""))
set fvar = new_CFileVar(FLD_OVERLAY, "Position", nvl(overlayNode.getAttribute("position"), ""))
set fvar = new_CFileVar(FLD_OVERLAY, "Font Size", nvl(overlayNode.getAttribute("fontSize"), ""))

overlayMenuTLBData.setItemAttribute "Background Color.vbs", "leftText", nvl(overlayNode.getAttribute("backgroundColor"), "")
overlayMenuTLBData.setItemAttribute "Font Color.vbs", "leftText", nvl(overlayNode.getAttribute("fontColor"), "")
overlayMenuTLBData.save
'End Overlay

gws.sendkeys HK_TEREFRESH
